<?
/**
 * RDFS-class viewer and editor.
 * 
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: class.php,v 1.80 2004/12/20 20:30:30 soerenauer Exp $
 **/
@include_once('../../include.php');

$isNew=false;
if(empty($_REQUEST['uri']) || !$class=$_ET['rdfsmodel']->getClass($_REQUEST['uri'])) {
	$isNew=true;
	$class=new $_ET['rdfsmodel']->vclass(!empty($_REQUEST['uri'])?$_REQUEST['uri']:$_ET['rdfsmodel']->getUniqueResourceURI((!empty($_REQUEST['parent'])?ereg_replace('^.*[:#]','',$_REQUEST['parent']):'').'Class'),$_ET['rdfsmodel']);
}
#var_dump($_ET['rdfsmodel']->getClass($_REQUEST['uri']));

$editable=$powl->aclCheck('Edit',$_ET['rdfsmodel'])&&(!$class->isImported()||$isNew)?true:false;

if(!isset($_REQUEST['parent']))
	$_REQUEST['parent']='';
if($_SERVER['REQUEST_METHOD']=='POST') {
	if(!$editable)
		pwlDeny();
	if(!empty($_REQUEST['uri'])) {
		$class->model->logStart('Class changed',$class->getLocalName(),$_POST['versioningDetails']);
		if($class->getLocalName()!=$_REQUEST['name'])
			if($class->rename($_ET['rdfsmodel']->baseURI.$_REQUEST['name']))
				$feedback='<script language="javascript">parent.frames[\'tree\'].location.reload();</script>';
	} else {
		$class->model->logStart('Class added',$class->getLocalName(),$_POST['versioningDetails']);
		if(!empty($_REQUEST['parent'])) {
			$parent=$_ET['rdfsmodel']->getClass($_REQUEST['parent']);
			$class=$parent->addSubClass($_REQUEST['name']);
		} else
			$class=$_ET['rdfsmodel']->addClass($_REQUEST['name']);
		$isNew=false;
		$feedback='<script language="javascript">parent.frames[\'tree\'].location.reload();</script>';
	}
	// set class properties
	if(!empty($_REQUEST['cardinalityMin']))
		foreach($_REQUEST['cardinalityMin'] as $key=>$value)
			$class->setCardinalityMin($key,$value);
	if(!empty($_REQUEST['cardinalityMax']))
		foreach($_REQUEST['cardinalityMax'] as $key=>$value)
			$class->setCardinalityMax($key,$value);
	foreach(array('subClasses','superClasses','equivalentClasses','disjointWith','intersectionOf','unionOf','complementOf') as $value)
		if(method_exists($class,"set$value"))
			call_user_func(array($class,"set$value"),!empty($_REQUEST[$value])?$_REQUEST[$value]:'');
	pwlResourceMetaProcess($class);
}
if(!empty($_REQUEST['action'])) {
	if(!$editable)
		pwlDeny();
	switch($_REQUEST['action']) {
		case 'remove':
			pwlHTMLHeader();
			if($class->listInstances())
				echo(pwl_('There are still instances of this class. Please delete them first!'));
			else {
				$class->model->logStart('Class removed',$class->getLocalName(),$_POST['versioningDetails']);
				$class->remove();
				echo('<script language="javascript">parent.frames[\'tree\'].location.reload();</script>');
			}
			pwlHTMLFooter();
			exit;
			break;
		case 'removeProperty':
			$class->removeProperty($_REQUEST['property']);
			break;
	}
}
pwlHTMLHeader(($isNew?'Create New':($editable?'Edit':'View'))." Class");
if(!empty($feedback))
	echo($feedback/*.'<div class="feedback">'.pwl_('Class updated').'.</div>'*/);
?>
<form method="POST">
<input type="hidden" name="parent" value="<?=$_REQUEST['parent']?>"/>
<input type="hidden" name="uri" value="<?=$isNew?'':$class->getLocalName()?>"/>
<input type="text" name="name" value="<?=$class->getLocalName()?>" style="font-weight:bold; width:400px;"<?=$editable?'':' readonly="readonly"'?>>
<h2><?=pwlHTMLOptional('properties','class')?><img src="<?=$_POWL['uriBase']?>images/Properties.gif">&nbsp;<?= pwl_("Properties") ?></h2>
<div id="properties">
<?
function pwlShowProperties($class,$properties,$deleteable) {
	global $editable;
	?>
	<table>
	<tr>
		<th rowspan="2"><?= pwl_("Name") ?></th>
		<th rowspan="2"><?= pwl_("Range") ?></th>
	<?
	if(method_exists($class,'setCardinality')) { ?>
		<th colspan="2"><?= pwl_("Cardinality") ?></th>
		<th rowspan="2"><?= pwl_("Other restrictions") ?></th>
	<? }
	if($editable)
		echo('<th rowspan="2">'.pwl_("Action").'</th>')
	?>
	</tr>
	<? if(method_exists($class,'setCardinality')) { ?>
	<tr><th style="padding:0px;"><?= pwl_("min") ?></th><th style="padding:0px;"><?= pwl_("max") ?></th></tr>
	<? } else echo('<tr></tr>');
	$i=0;
	foreach($properties as $prop) {
		$ranges=$prop->listRange();
		$label=$prop->getLabelForLanguage($_SESSION['PWL']['language'])?$prop->getLabelForLanguage($_SESSION['PWL']['language']):($prop->getLabelForLanguage('en')?$prop->getLabelForLanguage('en'):$prop->getLabelForLanguage());
		$comment=$prop->getComment($_SESSION['PWL']['language'])?$prop->getComment($_SESSION['PWL']['language']):$prop->getComment('en');
		$comment=$comment?$comment:$prop->getComment();
		echo('<tr'.($i++%2==0?' class="even"':'').' nowrap="nowrap">
			<td nowrap="nowrap"><img align="middle" title="'.pwl_(($prop->type($GLOBALS['OWL_DatatypeProperty'])?'Datatype':'Object').' property'.($cl==$class->getLocalName()?'':' inherited')).'" src="'.$GLOBALS['_POWL']['uriBase'].'images/'.($prop->type($GLOBALS['OWL_DatatypeProperty'])?'Datatype':'Object').'Property'.($cl==$class->getLocalName()?'':'Inherited').'.gif">&nbsp;'.($comment?'&nbsp;<span title="'.($label?$label.': ':'').$comment->getLabel().'" class="help">'.$prop->getLocalName().'</span>':$prop->getLocalName()).'</td>
			<td nowrap="nowrap">');
			if(!method_exists($prop,'listRangeFromUnionClass'))
				echo(join(', ',array_keys($prop->listRange())));
			else if($union=$prop->listRangeFromUnionClass())
				echo(join(', ',array_keys($union)));
			else if($data=$prop->listRangeFromDataRange())
				echo('\''.join('\', \'',array_keys($data)).'\'');
			echo('</td>');
		if(method_exists($class,'setCardinality')) {
			echo(($prop->isFunctional()?'<td colspan="2" align="center">functional</td>':'
			<td><input type="text" name="cardinalityMin['.$prop->getURI().']" size="2" value="'.$class->getCardinalityMin($prop).'"'.($editable && !$GLOBALS['isNew']?'':' readonly="readonly"').'></td>
			<td><input type="text" name="cardinalityMax['.$prop->getURI().']" size="2" value="'.$class->getCardinalityMax($prop).'"'.($editable && !$GLOBALS['isNew']?'':' readonly="readonly"').'></td>
			').'
			<td nowrap="nowrap">');
			if($editable && !$GLOBALS['isNew'])
				echo('<a href="javascript:powl.winopen(\'restriction.php?class='.urlencode(urlencode($class->getURI())).'&property='.urlencode(urlencode($prop->getURI())).'\',\'restriction\',\'width=400,height=450\');" title="'.pwl_('Edit restriction').'">');
			if($res=$class->getRestriction($prop)) {
				foreach($res as $inh=>$restr) {
					if(is_a($restr->obj,'Blanknode') && ($class->model->findStatement($restr->obj,$GLOBALS['RDF_type'],$GLOBALS['OWL_Class']) || $class->model->findStatement($restr->obj,$GLOBALS['RDF_type'],$GLOBALS['OWL_DataRange']))) {
						if($stm=$class->model->findStatement($restr->obj,$GLOBALS['OWL_oneOf'],NULL))
							$restrictionLabel=join(', ',array_keys($class->model->getList($stm->obj)));
						else
							$restrictionLabel=join(', ',array_keys($class->model->getList($stm->obj)));
					} else
						$restrictionLabel=(is_a($restr->obj,'Resource')?$restr->obj->getLocalName():$restr->obj->getLabel());
					if($restr->pred->getURI()==$GLOBALS['OWL_allValuesFrom']->getURI())
						echo('<img src="'.$GLOBALS['_POWL']['uriBase'].'images/AllRestriction.gif" align="absmiddle" /> '.$restrictionLabel.'</a>'.($inh!=$class->getLocalName()?' ('.$inh.')':'').'<br />');
					else if($restr->pred->getURI()==$GLOBALS['OWL_someValuesFrom']->getURI())
						echo('<img src="'.$GLOBALS['_POWL']['uriBase'].'images/SomeRestriction.gif" align="absmiddle" /> '.$restrictionLabel.'</a>'.($inh!=$class->getLocalName()?' ('.$inh.')':'').'<br />');
					else if($restr->pred->getURI()==$GLOBALS['OWL_hasValue']->getURI())
						echo('<img src="'.$GLOBALS['_POWL']['uriBase'].'images/HasRestriction.gif" align="absmiddle" /> '.$restrictionLabel.'</a>'.($inh!=$class->getLocalName()?' ('.$inh.')':'').'<br />');
				}
			} else if($editable && !$GLOBALS['isNew'])
				echo('[A]</a>');
			echo('</td>');
		}
		if($editable)
			echo('<td><a href="javascript:powl.winopen(\'../properties/property.php?uri='.urlencode(urlencode($prop->getURI())).'\');" title="'.pwl_('Edit').'"><img src="'.$GLOBALS['_POWL']['uriBase'].'images/edit.gif"></a>&nbsp;
				'.($deleteable?'<a onclick="return confirm(\'Do you really want to delete this object?\')" href="?uri='.urlencode($class->getURI()).'&action=removeProperty&property='.urlencode($prop->getURI()).'"><img src="'.$GLOBALS['_POWL']['uriBase'].'images/delete.gif" title="'.pwl_('Remove').'"></a>':'').'</td>');
		echo('</tr>');
	}
	if(!$i)
		echo('<tr><td colspan="7">'.pwl_("No properties defined yet").'</tr>');
	
	?>
	<tr><th colspan="7" align="left">
	<? if($editable && $deleteable && !$GLOBALS['isNew']) { ?>
	<a href="javascript:powl.winopen('../properties/property.php?domain=<?=urlencode(urlencode($class->getLocalName()))?>');"><img src="<?=$GLOBALS['_POWL']['uriBase']?>images/item_ltr.png" align="absmiddle">&nbsp;<?= pwl_("Add property") ?></a>
	<? } ?>
	&nbsp;</th></tr>
	</table>
	<?
}
if($_REQUEST['parent'])
	$parent=$_ET['rdfsmodel']->getClass($_REQUEST['parent']);
$p=!empty($_REQUEST['uri'])?$class->listProperties():(!empty($parent)?array_merge(array($class->getLocalName()=>array()),$parent->listProperties()):array($class->getLocalName()=>array()));
foreach($p as $inh=>$props)
	if($props || $inh==$class->getLocalName())
		$t[$inh]=($inh==$class->getLocalName()?'Direct&nbsp;Properties':'From&nbsp;'.$inh);
$tab=new tab();
echo($tab->show($t));
foreach($p as $cl=>$props)
	if($props || $cl==$class->getLocalName()) {
		echo('<div id="'.$cl.'" class="tabarea" style="width:auto;">');
		pwlShowProperties($class,$props,$cl==$class->getLocalName());
		echo('</div>');
	}
?>
<p />
</div>
<?
$tab=new tab();
echo('<table class="blind"><tr><td><h2 style="margin:0px;">'.pwlHTMLOptional('axioms','class').pwl_('Axioms').'</h2></td><td><h2 style="margin:0px;">'.pwl_('Description').'</h2></td></tr><tr id="axioms"><td>');
$tabs=array('subClasses'=>pwl_('Sub'),'superClasses'=>pwl_('Super'),'equivalentClasses'=>pwl_('Equivalent'),'disjointWith'=>pwl_('Disjoint'));
echo($tab->show($tabs));
$selectClassConfig=array('AttributeStyle'=>'height:70px;width:245px;');
if(!$editable)
	$selectClassConfig['readonly']=true;
$cs=new selectClass($selectClassConfig);
foreach($tabs as $key=>$val)
	echo('<div id="'.$key.'" class="tabarea" style="width:248px; height:100px;">'.(method_exists($class,"list$key")?$cs->edit($key,$_REQUEST['parent']&&$key=='superClasses'?$_REQUEST['parent']:array_keys(call_user_func(array(&$class,"list$key")))):'').'</div>');

$tabs=array('intersectionOf'=>pwl_('Intersection'),'unionOf'=>pwl_('Union'),'complementOf'=>pwl_('Complement'));
echo('</td><td>'.$tab->show($tabs));
$cs=new selectClass($selectClassConfig);
foreach($tabs as $key=>$val)
	echo('<div id="'.$key.'" class="tabarea" style="width:248px; height:100px;">'.(method_exists($class,"list$key")?$cs->edit($key,array_keys(call_user_func(array(&$class,"list$key"))),$key=='complementOf'?array('cardinalityMax'=>1):array()):'').'</div>');

echo('</td></tr></table>'.pwlResourceMetaShow($class));

if($editable)
	echo(pwlResourceVersioning($class,true,$editable).'<br /><INPUT type="submit" value="'.pwl_($isNew?'Create':'Save changes').'" onclick="powl.wait(this)" />');
?>
</form>
<? pwlHTMLFooter(); ?>