<html>
<head>
<title>Beispiel f&uuml;r GeoClass/OpenGeoDB</title>
</head>
<body>
<?php

/*
 ###########################################################
 #
 # Beispiel fr die Verwendung der GeoClass (0.2.1 beta)
 # mit den Daten der OpenGeoDB (>= 0.1.1)
 #
 # Daten:    http://opengeodb.de/download/
 # GeoClass: http://opengeodb.de/software/
 #
 # Erfordert PEAR::DB
 #
 ###########################################################
 */

/**
 * Konfiguration
 */
error_reporting(E_ALL & ~E_NOTICE);
if (!defined('DSN')) {
	// Hier mssen die Zugangsdaten fr die Datenbank eingetragen werden:
	define('DSN','mysql://root@localhost/rdfapi3');
}

if (!defined('PATH_DATA')) {
	// Hier muss der Pfad zu den E00-Dateien angegeben werden (zum Neuzeichnen der Karte)
	// Die Datei germany_staatline.e00 ist erhltlich unter http://opengeodb.de/download/
	// E00-Dateien fr Staatsgrenzen gibt es bei http://www.maproom.psu.edu/dcw/
	define('PATH_DATA','/pfad/e00/');
}

/**
 * GeoClass einbinden und instanzieren
 *
 * Das Verzeichnis Geo muss sich im
 * Include-Verzeichnis befinden.
 */

require_once('Geo/Geo.php');

$options = array(
	'table' => "geodb_locations",
	'fields' => array(
		'name' => 'name',
		'longitude' => 'laenge',
		'latitude' => 'breite',
	),
);

$geodb = Geo::setupSource("DB",DSN,$options);


/**
 * Der folgende Teil wird in spteren Versionen
 * berflssig sein, da dies von der GeoClass
 * erledigt werden wird.
 */

// Verbindung zur Datenbank
$db = DB::connect(DSN, true);

if (DB::isError($db))
	die ($db->getMessage());

$db->setFetchMode(DB_FETCHMODE_ASSOC);


// Informationen fr die verschiedenen Fremdschlssel auslesen

$res = $db->query('SELECT adm0,name FROM geodb_adm0');
while ($row = $res->fetchRow()) {
	$staaten[$row['adm0']] = $row['name'];
}

$res = $db->query('SELECT adm1,adm0,name FROM geodb_adm1 ORDER BY adm0 DESC,adm1');
while ($row = $res->fetchRow()) {
	$laender[$row['adm0']][$row['adm1']] = $row['name'];
}

$res = $db->query('SELECT DISTINCT adm2 AS name FROM geodb_locations WHERE adm2 IS NOT NULL ORDER BY adm2');
while ($row = $res->fetchRow()) {
	$regbezirke[] = $row['name'];
}

$res = $db->query('SELECT DISTINCT adm3 AS name FROM geodb_locations ORDER BY adm3');
while ($row = $res->fetchRow()) {
	$landkreise[] = $row['name'];
}

$res = $db->query('SELECT * FROM geodb_typ');
while ($row = $res->fetchRow()) {
	$typen[$row['typ']] = array(
		"fld"=>$row['fld'],
		"name"=>$row['name']
	);
}


/**
 * Verarbeitung der Benutzereingaben
 */

if (!empty($_GET["id"])) {

	// Ein Datensatz ausgewhlt

	// Zurck zur Suche
	echo '<div style="float:right" class="small">';
	echo '<a href="'.$_SERVER['PHP_SELF'].'?q='.urlencode($_GET['q']).'">zurck zur Suche</a>';
	echo '</div>';

	// Datensatz des gewhlten Ortes auslesen
	$sql = 'SELECT * FROM geodb_locations WHERE id='.(int)$_GET["id"];
	list($ort) = $geodb->performQuery($sql);
	echo '<h2>'.$ort->dbValues['name'].'</h2>';


	// Karte zeichnen, wenn erforderlich
	if (!file_exists('maps/'.(int)$_GET["id"].'.png') || $_GET["newMap"]) {

		// Der Parameter newMap erzwingt das Neuzeichnen der Karte
		if ($_GET["newMap"]) {
			$map2 = Geo::setupMap(188,235);
			$map2->setRange(5.5, 15.5, 47.2, 55.1);
			$map2->color['borders'] = $map2->color(192, 192, 192);
			$map2->color['states'] = $map2->color(212, 212, 212);

			$map2->addDataFile(PATH_DATA."germany_staatline.e00", 'states'); // Grenzen Bundeslnder
			$map2->addDataFile(PATH_DATA."ponet.e00", 'borders'); // Grenzen Staat
			$map2->saveImage('maps/D.png');
		} else {
			$map2 = Geo::setupMap("maps/D.png");
			$map2->setRange(5.5, 15.5, 47.2, 55.1);
		}

		$map2->addGeoObject($ort, 'red', 6);
		$map2->saveImage('maps/'.(int)$_GET["id"].'.png');
	}

	echo '<div style="float:left">';
	echo '<img src="maps/'.(int)$_GET["id"].'.png" width="188" height="235" alt="Lage von '.$ort->dbValues['name'].' in Deutschland">';
	echo '</div>';

	// Detailinfos zum gewhlten Ort

	// Verwaltungsgliederung
	echo '<table cellpadding=0 cellspacing=0 width="400">';
	echo '<tr><td colspan=2 style="border-bottom:1px solid #CCCCCC;"><b>Verwaltungsgliederung</b></td></tr>';
	echo '<tr><td valign="top" width="150">Staat&nbsp;</td><td valign="top">'.$staaten[$ort->dbValues["adm0"]].'</td></tr>';
	if ($ort->dbValues["adm1"])
		echo '<tr><td valign="top">Bundesland&nbsp;</td><td valign="top">'.$laender[$ort->dbValues["adm0"]][$ort->dbValues["adm1"]].'</td></tr>';
	if ($ort->dbValues["adm2"])
		echo '<tr><td valign="top">Regierungsbezirk&nbsp;</td><td valign="top">'.$ort->dbValues["adm2"].'</td></tr>';
	if ($ort->dbValues["adm3"])
		echo '<tr><td valign="top">Landkreis</td><td valign="top">'.$ort->dbValues["adm3"].'</td></tr>';
	if ($ort->dbValues["adm4"])
		echo '<tr><td valign="top">Verwaltungsgemeinschaft&nbsp;</td><td valign="top">'.$ort->dbValues["adm4"].'</td></tr>';
	if ($ort->dbValues["typ"]>6)
		echo '<tr><td valign="top">Stadt/Gemeinde&nbsp;</td><td valign="top">'.$ort->dbValues["ort"].'</td></tr>';
	echo '</table><br>';

	// Koordinaten
	echo '<table cellpadding=0 cellspacing=0 width="400">';
	echo '<tr><td colspan=2 style="border-bottom:1px solid #CCCCCC;"><b>Koordinaten</b></td></tr>';
	echo '<tr><td valign="top" width="150">Lnge</td><td valign="top">'.$ort->dbValues["laenge"].' &nbsp;/&nbsp; '.$ort->longitudeDMS.'</td></tr>';
	echo '<tr><td valign="top">Breite</td><td valign="top">'.$ort->dbValues["breite"].' &nbsp;/&nbsp; '.$ort->latitudeDMS.'</td></tr>';
	echo '</table><br>';

	// Zusatzinformationen
	echo '<table cellpadding=0 cellspacing=0 width="400">';
	echo '<tr><td colspan=2 style="border-bottom:1px solid #CCCCCC;"><b>Zusatzinformationen</b></td></tr>';
	if ($ort->dbValues["gs"])
		echo '<tr><td valign="top" width="150">Gemeindekennzahl&nbsp;</td><td valign="top">'.$ort->dbValues["gs"].'</td></tr>';
	if ($ort->dbValues["kfz"])
		echo '<tr><td valign="top" width="150">Kfz-Kennzeichen&nbsp;</td><td valign="top">'.$ort->dbValues["kfz"].'</td></tr>';
	if ($ort->dbValues["plz"]) {
		$plz = explode(",",$ort->dbValues["plz"]);
		if (count($plz) > 3) {
			echo '<tr><td valign="top" width="150">Postleitzahl(en)&nbsp;</td><td valign="top">'.$plz[0].', '.$plz[1].', '.$plz[2].' <a href="#" title="'.join(", ",$plz).'">...</a></td></tr>';
		} else {
			echo '<tr><td valign="top" width="150">Postleitzahl(en)&nbsp;</td><td valign="top">'.join(", ",$plz).'</td></tr>';
		}
	}
	echo '</table><br>';

	// Externe Informationsquellen
	echo '<p style="clear:all;border-bottom:1px solid #CCCCCC;"><b>Externe Informationsquellen</b></p>';
	echo '<ul>';
	echo '<li><b><a href="http://de.wikipedia.org/w/wiki.phtml?search='.urlencode($ort->dbValues['name']).'&go=Los" target="_blank">'.$ort->dbValues['name'].'</a></b> suchen in <i><a href="http://de.wikipedia.org" target="_blank">Wikipedia - Die freie Enzyklopdie</a></i></li>';
	echo '<li><b><a href="http://www.google.de/search?hl=de&q='.urlencode('"'.$ort->dbValues['name'].'"').'&meta=lr%3Dlang_de" target="_blank">'.$ort->dbValues['name'].'</a></b> suchen in <i><a href="http://google.de" target="_blank">Google</a></i></li>';
	// echo '<li><b><a href="http://www.bund.de/Staedte-Kreise-Gemeinden-.6476.htm?neuesuche=true&neueseitenzahl=0&startsuche=true&blocknumber=1&neueseitenzahl=0&gemeinde='.urlencode($ort->dbValues['name']).'" target="_blank">'.$ort->dbValues['name'].'</a></b> suchen in <i><a href="http://www.bund.de/Staedte-Kreise-Gemeinden-.6476.htm" target="_blank">Verzeichnis Stdte, Kreise & Gemeinden (bund.de)</a></i></li>';
	echo '</ul>';

	// Orte in der Umgebung finden
	$treffer = $geodb->findCloseByGeoObjects($ort, 10, false);
	$home = $ort;
	if (is_array($treffer) && count($treffer)>1) {
		echo '<div style="border-bottom:1px solid #CCCCCC;"><b>Orte im Umkreis von 10 km</b></div><br>';
		echo '<ol>';
		foreach ($treffer AS $ort) {
			if ($home->dbValues["id"] != $ort->dbValues["id"]) {
				echo '<li>';
				if ($ort->dbValues['typ']>6) {
					echo '<a href="'.$_SERVER['PHP_SELF'].'?id='.$ort->dbValues['id'].'&q='.$_GET['q'].'">'.$ort->dbValues['name'].'</a>';
				} else {
					echo '<b><a href="'.$_SERVER['PHP_SELF'].'?id='.$ort->dbValues['id'].'&q='.$_GET['q'].'">'.$ort->dbValues['name'].'</a></b>';
				}
				echo '<br>';

				echo '<small>';
				echo $staaten[$ort->dbValues["adm0"]];
				echo ' &gt; '.$laender[$ort->dbValues["adm0"]][$ort->dbValues["adm1"]];
				echo ' &gt; '.$ort->dbValues["adm3"];
				if ($ort->dbValues["adm4"]) {
					echo ' &gt; '.$ort->dbValues["adm4"];
				}
				if ($ort->dbValues["typ"]>6) {
					echo ' &gt; '.$ort->dbValues["ort"];
				}
				echo '<br>Entfernung: '.$home->getDistanceString($ort).'';
				echo '</small>';
				echo '</li>';
			}
		}
		echo '</ol>';
	}

} else {

	// Suchformular

	echo '<h2>Ortsdatenbank</h2>';

	echo '<form action="'.$_SERVER['PHP_SELF'].'" method="GET">';
	echo '<input style="width:200px;" type="text" name="q" value="'.htmlentities($_GET["q"]).'">';
	echo '<input type="submit" name="" value="Suche starten">';
	echo '</form>';

	if ($_GET["q"]) {

		// Suchbegriff

		// Suche durchfhren
		if (preg_match('/^[0-9]{1,5}$/',$_GET["q"])) {
			$sql = 'SELECT * FROM geodb_locations WHERE plz LIKE "%'.$_GET["q"].'%"';
		} else {
			$sql = 'SELECT * FROM geodb_locations WHERE name LIKE "%'.$_GET["q"].'%"';
		}
		$treffer = $geodb->performQuery($sql);

		// Anzahl Treffer
		echo 'Ihre Suche nach "'.$_GET["q"].'" ergab '.count($treffer).' Treffer:<br>';

		// Trefferliste (wenn vorhanden)
		if (is_array($treffer) && count($treffer)>=1) {
			echo '<ol>';
			foreach ($treffer AS $ort) {
				echo '<li>';
				if ($ort->dbValues['typ']>6) {
					echo '<a href="'.$_SERVER['PHP_SELF'].'?id='.$ort->dbValues['id'].'&q='.$_GET['q'].'">'.$ort->dbValues['name'].'</a><br>';
				} else {
					echo '<b><a href="'.$_SERVER['PHP_SELF'].'?id='.$ort->dbValues['id'].'&q='.$_GET['q'].'">'.$ort->dbValues['name'].'</a></b><br>';
				}
				echo '<small>';
				echo $staaten[$ort->dbValues["adm0"]];
				echo ' &gt; '.$laender[$ort->dbValues["adm0"]][$ort->dbValues["adm1"]];
				echo ' &gt; '.$ort->dbValues["adm3"];
				if ($ort->dbValues["adm4"]) {
					echo ' &gt; '.$ort->dbValues["adm4"];
				}
				if ($ort->dbValues["typ"]>6) {
					echo ' &gt; '.$ort->dbValues["ort"];
				}
				echo '</small>';
				echo '</li>';
			}
			echo '</ol>';
		}
	} else {
		// Kein Suchbegriff
		echo "Bitte geben Sie als Suchbegriff einen<br>Namensbestandteil oder eine Postleitzahl ein.";
	}
}
?>
</body>
</html>