<?
/**
 * Export instance data as CSV.
 * 
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: export.php,v 1.12 2005/11/01 13:08:22 soerenauer Exp $
 **/

include('../../include.php');

$class=$_ET['rdfsmodel']->getClass($_REQUEST['uri']);

if($_POST) {
	header("Pragma: no-cache");
	header("Cache-Control: no-cache, must-revalidate, max_age=0");
	header("Expires: 0");
	
	$lineStart=$_REQUEST['enclosed'];
	$lineEnd=$_REQUEST['enclosed']."\n";
	$cellDelimiter=$_REQUEST['enclosed'].$_REQUEST['delimiter'].$_REQUEST['enclosed'];
	
	$cols[]='Instance';
	$properties=array();
	foreach($_REQUEST['properties']?$_REQUEST['properties']:$class->listPropertiesPlain() as $p)
		if($p!='rdfs:label') {
			$properties[]=$p;
			$cols[]=$p;
		}

	if(!$_REQUEST['properties'] || in_array('rdfs:label',$_REQUEST['properties'])) {
		foreach($class->listInstanceLabelLanguages() as $l)
			$labels['Label ('.$l.')']='';
		$cols=array_merge($cols,array_keys($labels));
	}
	$csv.=$lineStart.join($cellDelimiter,$cols).$lineEnd;
	foreach($class->findInstances(empty($_REQUEST['search'])?array():array($_REQUEST['property']=>$_REQUEST['search']),empty($_REQUEST['compare'])?'':$_REQUEST['compare']) as $instance) {
		$csv.=$lineStart.$instance->getLocalname();
#		if($_REQUEST['properties']) {
			foreach($properties as $pv) if($pv!='rdfs:label')
				$csv.=$cellDelimiter.join($_REQUEST['valueSeparator'],$instance->listPropertyValuesPlain($pv));
#		} else
#			foreach($instance->listAllPropertyValuesPlain() as $pv)
#				$csv.=$cellDelimiter.join($_REQUEST['valueSeparator'],$pv);
		if(!$_REQUEST['properties'] || in_array('rdfs:label',$_REQUEST['properties']))
			$csv.=$cellDelimiter.join($cellDelimiter,array_merge($labels,$instance->listLabelsPlain('Label (',')')));
		$csv.=$lineEnd;
	}
	if(!empty($_REQUEST['compression']))
		echo(pwlCompression($csv,$_REQUEST['compression'],urlencode($class->getLocalName().'.csv')));
	else {
		header("Content-Type: text/csv");
		header("Content-Disposition: filename=".urlencode($class->getLocalName().".csv"));
		echo($csv);
	}
	exit;
}
pwlHTMLHeader();
?>
<h1><?=pwl_('Export instance data:').' '.$class->getLocalName()?></h1>
<form method="post">
<p>Filter:<br />
<?
foreach($class->listPropertiesUsed() as $p)
	$properties[$p->getURI()]=$p->getLocalName();

$l=array($GLOBALS['RDFS_label']->getURI()=>'Label');
$s=new select(array('cardinalityMax'=>1,'AttributeStyle'=>'width:30%;'));
echo($s->edit('property',empty($_REQUEST['property'])?'':$_REQUEST['property'],array_merge(array('localName'=>'localName'),$l,$properties)));
echo($s->edit('compare',empty($_REQUEST['compare'])?'':$_REQUEST['compare'],array('exact'=>'exactly matching','starts'=>'starting with','contains'=>'containing','regex'=>'regex matching')));
?>
<input type="text" name="search" style="width:30%;" value="" />
</p>
<p>Properties:<br />
<?
$p=array_keys($class->listPropertiesUsed());
pwlArrayCopyValues2Indexes($p);
echo(select::edit('properties',$p,$p,array('multisize'=>'5')));
?></p>
<input type="hidden" name="uri" value="<?=$_REQUEST['uri']?>" />
<?=pwl_('File type:')?><br />
<?
	$s=new select(array('cardinality'=>1));
	echo($s->edit('filetype','csv',array('csv'=>'CSV','rdf'=>'RDF/XML','n3'=>'N3','nt'=>'N-Triples')));
?><br />
<div style="margin-left:25px;">
<div id="csv">
	<p><?=pwl_('Fields delimited by:');?><br />
	<input type="text" name="delimiter" value=";" /></p>
	<p><?=pwl_('Optionally enclosed by:');?><br />
	<input type="text" name="enclosed" value="&quot;" /></p>
	<p><?=pwl_('Multiple property values separated by:');?><br />
	<input type="text" name="valueSeparator" value="," /></p>
</div>
<div id="rdf">
	<?=pwl_('Include reference to XSLT stylesheet:');?><br />
	<?=$s->edit('xslt','',array(''=>'-','./xslt/kanzaki/styles.xsl'=>'Stylesheet by Masahide Kanzaki'))?><br />
	<input type="checkbox" name="nestBNodes" /> <?=pwl_('nest blank nodes (experimental)');?><br />
	<input type="checkbox" name="nsIntuitiveAbbrev" /> <?=pwl_('use intuitive abbreviation for common namespaces (experimental)');?><br />
</div>
</div>
<?
pwlCompressionDialog();
?>
<input type="submit" value="<?= pwl_("Export") ?>" /><p></p>
</form>
<?
pwlHTMLFooter();
?>