<?
/**
 * RDF versioning viewer.
 * 
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: compare.php,v 1.9 2004/11/16 10:18:31 soerenauer Exp $
 **/

include('../../include.php');
pwlHTMLHeader();
?>
<h1><?=pwl_('Compare models')?></h1>
<?
$m1=$_ET['store']->getModel(array_shift($_REQUEST['selected']));
$m2=$_ET['store']->getModel(array_pop($_REQUEST['selected']));
$url='?selected[0]='.urlencode($m1->modelURI).'&selected[1]='.urlencode($m2->modelURI).'&operation=';

$t=new tab(array('urlbase'=>$url));
if(empty($_REQUEST['operation']))
	$_REQUEST['operation']='greater';
echo($t->show(array(
	'greater'=>$m1->modelURI.' >> '.$m2->modelURI,
	'equal'=>$m1->modelURI.' == '.$m2->modelURI,
	'smaller'=>$m2->modelURI.' >> '.$m1->modelURI),$_REQUEST['operation']));
if(empty($_REQUEST['search']))
	$search='';
else
 	foreach($_REQUEST['search'] as $key=>$val) if($val) {
		switch($key) {
			case 'resource':
				$search=" AND (s1.subject='$val' OR s1.predicate='$val' OR s1.object='$val')";
				break;
			case 'literal':
				$search=" AND (s1.object_is='l' AND s1.object='$val')";
				break;
			case 'datatype':
				$search=" AND (s1.object_is='l' AND s1.l_datatype='$val')";
				break;
			case 'language':
				$search=" AND (s1.object_is='l' AND s1.l_language='$val')";
				break;
			default:
				$search=" AND s1.$key='$val'";
		}
		$filter="<a href=\"".pwlURLParamReplace("search[$key]",'')."\">$key: $val</a> |";
	}
if($_REQUEST['operation']=='equal')
	$sql='SELECT s1.subject,s1.predicate,s1.object,s1.l_language,s1.l_datatype,s1.subject_is,s1.object_is
		FROM statements s1 INNER JOIN statements s2
		USING(subject,predicate,object,l_language,l_datatype,subject_is,object_is)
		WHERE s1.modelID="'.$m1->modelID.'" AND s2.modelID="'.$m2->modelID.'"'.$search;
else
	$sql='SELECT s1.subject,s1.predicate,s1.object,s1.l_language,s1.l_datatype,s1.subject_is,s1.object_is,s2.modelID
		FROM statements s1 LEFT JOIN statements s2
		ON(s1.subject=s2.subject AND s1.predicate=s2.predicate AND s1.object=s2.object AND s1.l_language=s2.l_language AND s1.l_datatype=s2.l_datatype AND s1.subject_is=s2.subject_is AND s1.object_is=s2.object_is
			 AND s2.modelID="'.($_REQUEST['operation']=='greater'?$m2->modelID:$m1->modelID).'")
		WHERE s1.modelID="'.($_REQUEST['operation']=='greater'?$m1->modelID:$m2->modelID).'"'.$search.'
		HAVING ISNULL(s2.modelID)';
echo('<p>&nbsp;</p><div style="clear:all">'.pwl_('Filter: ').(!empty($filter)?$filter:'').'<br />');
if(!empty($_REQUEST['action']) && $_REQUEST['action']=='copy') {
		$res=$_ET['store']->dbConn->execute($sql);
		$erg=$res->_maxRecordCount?$res->_maxRecordCount:$res->_numOfRows;
		echo "Copying $erg statements from $m1->modelURI to $m2->modelURI ... ";
		while($stm=$_ET['rdfsmodel']->fetchStatementFromRecordSet($res)) {
			$m2->add($stm);
		}
		echo('done!');
		unset($_REQUEST['action']);
}
$count=pwlSessionVar($_SERVER['PHP_SELF'],'count');
$start=empty($_REQUEST['start'])?0:$_REQUEST['start'];
$res=$m1->dbConn->pageExecute($sql,$count,$start/$count+1);
$erg=$res->_maxRecordCount?$res->_maxRecordCount:$res->_numOfRows;
echo(pwlListHead($start,$count,$erg));
?>
<table class="tripletable"><tr><th><?= pwl_("Nr.") ?></th><th><?= pwl_("Subject") ?></th><th><?= pwl_("Predicate") ?></th><th><?= pwl_("Object") ?></th><th><?= pwl_("Action") ?></th></tr>
<?
function showNode($node) {
	$ret=$node->getLabel();
	$ret=str_replace($GLOBALS['_ET']['rdfsmodel']->baseURI,'',$ret);
	foreach($GLOBALS['default_prefixes'] as $key=>$val)
		$ret=str_replace($val,$key.':',$ret);
	if(is_a($node,'Literal'))
		$ret='<a href="'.pwlURLParamReplace('search[literal]',urlencode($node->getLabel())).'">'.$ret.'</a> ( Language: <a href="'.pwlURLParamReplace('search[language]',urlencode($node->getLanguage())).'">'.($node->getLanguage()?$node->getLanguage():'-').'</a>, Datatype: <a href="'.pwlURLParamReplace('search[datatype]',urlencode($node->getDatatype())).'">'.($node->getDatatype()?$node->getDatatype():'-').'</a>)';
	else
		$ret='<a href="'.pwlURLParamReplace('search[resource]',urlencode($node->getURI())).'">'.$ret.'</a>';
	return $ret;
}

$i=0;
while($stm=$m1->fetchStatementFromRecordSet($res)) {
	echo('<tr class="'.(++$i%2==0?'':'even').'">
	        <td>'.$i.'</td>
			<td>'.showNode($stm->subj).'</td>
			<td>'.showNode($stm->pred).'</td>
			<td>'.showNode($stm->obj).'</td>
	        <td>
	           <a href="#" onclick="open(\'stm_edit.php?subj='.urlencode($stm->subj->getURI()).'&pred='.urlencode($stm->pred->getURI()).'&obj='.urlencode(is_a($stm->obj,'Resouce')?$stm->obj->getURI():$stm->obj->getLabel()).(is_a($stm->obj,'Literal')?'&isLiteral=isLiteral&lang='.$stm->obj->getLanguage().'&dtype='.$stm->obj->getDatatype():'').'\',\'stm_edit\',\'width=250,height=350\');" title="Edit"><img src="../../images/edit.gif"></a>
	           <a onclick="if(confirm(\'Do you really want to delete this object?\')) { form=document.forms[\'delform\']; form.reset(); document.getElementById(\'delformelem\'+'.$i.').checked=\'true\'; form.submit();}" href="#" title="'.pwl_('Delete').'"><img src="../../images/delete.gif"></a>
			</td>
	      </tr>');
}
?>
	<tr><th colspan="9" align="left"><img src="../../images/item_ltr.png">&nbsp;
<form><select onchange="
if(this.form.aktion.selectedIndex==1) {
	if(!confirm('<?= pwl_('Do you really want to delete this object?') ?>')) return;
}
document.location.href=this.form.aktion.value;" name="aktion" style="font-size:9px; font-weight:bold; background-color:#d3dce3;">
	<option value=""><?=pwl_('Statements:')?></option>
	<option value="<?=pwlURLParamReplace('action','delete')?>"><?=pwl_('Delete from').' '.($_REQUEST['operation']=='greater'?$m1->modelURI:$m2->modelURI)?></option>
<? if($_REQUEST[operation]=='equal') { ?>
	<option value="<?=pwlURLParamReplace('action','delete')?>"><?=pwl_('Delete from').' '.$m1->modelURI?></option>
<? } else { ?>
	<option value="<?=pwlURLParamReplace('action','copy')?>"><?=pwl_('Copy to').' '.($_REQUEST['operation']=='greater'?$m2->modelURI:$m1->modelURI)?></option>
	<option value="<?=pwlURLParamReplace('action','move')?>"><?=pwl_('Move to').' '.($_REQUEST['operation']=='greater'?$m2->modelURI:$m1->modelURI)?></option>
<? } ?>
</select></form>
</th></tr>
</table></div>
<? pwlHTMLFooter(); ?>