<?
include('../../../../include.php');
pwlHTMLHeader();
?>
<h1>Properties</h1>

Exerpt from <a href="http://www.w3.org/TR/owl-features">OWL Overview</a>:
<p><b><i><a id="property"
        name="property"></a><a href="http://www.w3.org/TR/owl-guide/#DefiningProperties">
        rdf:Property</a></i></b>: Properties can be used to state
        relationships between individuals or from individuals to
        data values. Examples of properties include hasChild,
        hasRelative, hasSibling, and hasAge. The first three can be
        used to relate an instance of a class Person to another
        instance of the class Person (and are thus occurences of
        <a href="http://www.w3.org/TR/owl-guide/#DefiningProperties">
        ObjectProperty</a>), and the last (hasAge) can be used to
        relate an instance of the class Person to an instance of
        the datatype Integer (and is thus an occurence of
        <a href="http://www.w3.org/TR/owl-guide/#DefiningProperties">
        DatatypeProperty</a>). Both owl:ObjectProperty and
        owl:DatatypeProperty are
        <a href="http://www.w3.org/TR/owl-ref/#ObjectProperty-def">subclasses</a>
        of the RDF class rdf:Property.</p>

<p><b><i><a id="subPropertyOf"
        name="subPropertyOf"></a><a href="http://www.w3.org/TR/owl-guide/#rdfs_subPropertyOf">
        rdfs:subPropertyOf</a></i></b>: Property hierarchies may be
        created by making one or more statements that a property is
        a subproperty of one or more other properties. For example,
        hasSibling may be stated to be a subproperty of
        hasRelative. From this a reasoner can deduce that if an
        individual is related to another by the hasSibling
        property, then it is also related to the other by the
        hasRelative property.</p>
		
<h2>On the Web</h2>
<ul>
<li><a href="http://www.w3.org/TR/rdf-schema/#ch_properties">Properties</a> (RDF Schema Vocabulary Description Language)</a></li>
<li><a href="http://www.w3.org/TR/owl-guide/#DefiningProperties">Defining Properties</a></li>
<li><a href="http://www.w3.org/TR/owl-ref/#Property">Property</a> (OWL Reference)</li>
<li><a href="http://www.w3.org/TR/owl-semantics/#owl_DatatypeProperty">owl:DatatypeProperty</a> (OWL Semantics)</li>
</ul>

<? pwlHTMLFooter(); ?>