<?
/**
 * RDFS-property viewer and editor.
 *
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: property.php,v 1.76 2006/01/31 19:01:14 soerenauer Exp $
 **/
@include_once('../../include.php');

$isNew=false;
if(empty($_REQUEST['uri']) || !$property=$_ET['rdfsmodel']->getProperty($_REQUEST['uri'])) {
	if(!empty($_REQUEST['domain']) && !is_array($_REQUEST['domain'])) {
		$cl=$_ET['rdfsmodel']->classF($_REQUEST['domain']);
		$prefix=strtolower($cl->getLocalName()).'P';
	} else $prefix='p';
	$property=new $_ET['rdfsmodel']->property(empty($_REQUEST['uri'])?$_ET['rdfsmodel']->getUniqueResourceURI($prefix.'roperty'):$_REQUEST['uri'],$_ET['rdfsmodel']);
	$isNew=true;
}

$editable=$powl->aclCheck('Edit',$_ET['rdfsmodel'])&&(!$property->isImported()||$isNew)?true:false;

pwlHTMLHeader(($isNew?'Create New':($editable?'Edit':'View'))." Property");

if($_SERVER['REQUEST_METHOD']=='POST') {
	if(!$editable)
		pwlDeny();
	if(!empty($_REQUEST['uri'])) { // rename
		$property->model->logStart('Property changed',$property->getLocalName(),$_POST['versioningDetails']);
		if($property->getLocalName()!=$_REQUEST['name'])
			if($property->rename($_ET['rdfsmodel']->baseURI.$_REQUEST['name']))
				echo('<script language="javascript">parent.frames[\'tree\'].location.reload();</script>');
	} else if($_REQUEST['name']) { // create new property
		$property->model->logStart('Property added',$property->getLocalName(),$_POST['versioningDetails']);
		if(!empty($_REQUEST['parent'])) {
			$parent=$_ET['rdfsmodel']->getProperty($_REQUEST['parent']);
			$property=$parent->addSubProperty($_REQUEST['name']);
		} else
			$property=$_ET['rdfsmodel']->addProperty($_REQUEST['name']);
	}
	// set domain
	$property->setDomainToUnionClass(!empty($_POST['domain'])?$_POST['domain']:'');
	// set range
	switch($_POST['range']) {
		case 'Instance':
			if(method_exists($property,'isObjectProperty'))
				$property->isObjectProperty(true);
			$property->setRangeToUnionClass($_POST['rangeInstances']);
			break;
		case 'Symbol':
			if(method_exists($property,'isDatatypeProperty'))
				$property->isDatatypeProperty(true);
			$property->setRangeToDataRange(split("\r\n",$_POST['rangeSymbols']));
			break;
		default:
			$property->isDatatypeProperty(true);
			$property->setRange($_POST['range']);
	}
	// set owl property chracteristics
	if($property->model->type=='OWL') {
		$property->isFunctional(!empty($_POST['functional'])?$_POST['functional']:'');
		$property->isInverseFunctional(!empty($_POST['inverseFunctional'])?$_POST['inverseFunctional']:'');
		$property->isTransitive(!empty($_POST['transitive'])?$_POST['transitive']:'');
		$property->isSymmetric(!empty($_POST['symmetric'])?$_POST['symmetric']:'');
		$property->isAnnotation(!empty($_POST['annotation'])?$_POST['annotation']:'');
	}
	foreach(array('subProperties','superProperties','equivalentProperties','inverseOf') as $value)
		if(method_exists($property,"set$value"))
			call_user_func(array(&$property,"set$value"),!empty($_REQUEST[$value])?$_REQUEST[$value]:'');

	// save metainformations for property
	pwlResourceMetaProcess($property);
	// set edit widget
	if(!empty($_POST['widget'])) {
		if(!$widgetInstance=pwlFindWidget($property)) {
			$widgetInstance=$GLOBALS['_POWL']['SysOnt']->addInstance($GLOBALS['_POWL']['SysOnt']->getUniqueResourceURI('Instance'),'WidgetSelection');
			$widgetInstance->setPropertyValue('widgetProperty',$property->getURI());
			$widgetInstance->setPropertyValue('widgetConfiguration',$_POST['widget']);
		} else
			$widgetInstance->setPropertyValue('widgetConfiguration',$_POST['widget']);
	} else if($widgetInstance=pwlFindWidget($property))
		$widgetInstance->remove();
	echo('<script language="javascript">if(opener) {opener.location.reload(); close(); } else parent.frames[\'tree\'].location.reload();</script>');
}
if(!empty($_REQUEST['action']) && $_REQUEST['action']=='remove') {
	if(!$editable)
		pwlDeny();
	$property->model->logStart('Property removed',$property->getLocalName(),$_POST['versioningDetails']);
	$property->remove();
	pwlHTMLHeader();
	echo('<script language="javascript">parent.frames[\'tree\'].location.reload();</script>');
	pwlHTMLFooter();
	exit;
}
?>
<form method="POST">
<input type="hidden" name="uri" value="<?=$isNew?'':$property->getLocalName()?>" />
<input type="text" name="name" value="<?=$property->getLocalName()?>" style="font-weight:bold; width:400px;"<?=$editable?'':' readonly="readonly"'?>>
<table class="blind"><tr><td><h2 style="margin-bottom:0px;"><?=pwlHTMLOptional('domain','property')?><?= pwl_("Domain") ?></h2></td><td><h2 style="margin-bottom:0px;"><?= pwl_("Range") ?></h2></td></tr>
<tr id="domain"><td>
<?
$eConfig=$editable?array():array('readonly'=>true);
$e=new selectClass($eConfig);
$dom=array();
if(!method_exists($property,'listRangeFromUnionClass'))
	$dom=array(parray_shift(array_keys($property->listDomain())));
else
	foreach($property->listDomainFromUnionClass() as $domain)
		$dom[]=$domain->getLocalName();
if(!empty($_REQUEST['domain']) && ! is_array($_REQUEST['domain']))
	$dom[]=$_REQUEST['domain'];
echo($e->edit('domain',$dom));
?>
</td><td>
<?
$rangeValues=array_merge(array(''=>'Any (undefined)','Symbol'=>'Enumeration',$GLOBALS['OWL_Class']->getURI()=>'Class','Instance'=>'Instance'),$_POWL['datatypes']);
$range=$property->getRange();
if($range && method_exists($property,'listRangeFromUnionClass')) {
	if(!in_array($range->getURI(),array_keys($rangeValues)) && $union=$property->listRangeFromUnionClass()) {
		$rangeInstances=array_keys($union);
		$range=new Resource('Instance');
	} else if($data=$property->listRangeFromDataRange()) {
		$rangeSymbols=array_keys($data);
		$range=new Resource('Symbol');
	}
} else if($range && !in_array($range->getURI(),$rangeValues)) {
	$rangeInstances=array($range->getLocalName());
	$range=new Resource('Instance');
}
$sConfig=array('cardinalityMax'=>1);
if(!$editable)
	$sConfig['readonly']=true;
$s=new select($sConfig);
echo($s->edit('range',!empty($range)?$range->getURI():($property->isObjectProperty()?'Instance':''),$rangeValues));
?><br />
<div id="Symbol">
<textarea name="rangeSymbols"><?=!empty($rangeSymbols)?join("\n",$rangeSymbols):''?></textarea>
</div>
<div id="Instance">
<?=pwl_('Allowed classes:')?><br />
<?=$e->edit('rangeInstances',$rangeInstances);?>
</div>
</td></tr></table>
<? if($property->model->type=='OWL') { ?>
<h2><?=pwlHTMLOptional('char','property')?><?= pwl_("Characteristics") ?></h2>
<div id="char">
<table class="blind"><tr>
<td><input type="checkbox" name="functional"<?=$property->isFunctional()?' checked':''?><?=$editable?'':' disabled="disabled"'?>> <?= pwl_("Functional") ?></td>
<td><input type="checkbox" name="inverseFunctional"<?=$property->isInverseFunctional()?' checked':''?><?=$editable?'':' disabled="disabled"'?>> <?= pwl_("Inverse functional") ?></td>
</tr><tr>
<td><input type="checkbox" name="transitive"<?=$property->isTransitive()?' checked':''?><?=$editable?'':' disabled="disabled"'?>> <?= pwl_("Transitive") ?></td>
<td><input type="checkbox" name="symmetric"<?=$property->isSymmetric()?' checked':''?><?=$editable?'':' disabled="disabled"'?>> <?= pwl_("Symmetric") ?></td>
<td><input type="checkbox" name="annotation"<?=$property->isAnnotation()?' checked':''?><?=$editable?'':' disabled="disabled"'?>> <?= pwl_("Annotation") ?></td>
</tr></table></div>
<? }
$tab=new tab();
echo('<h2>'.pwlHTMLOptional('axioms','property').pwl_('Axioms').'</h2><div id="axioms">');
$tabs=array('subProperties'=>pwl_('Sub'),'superProperties'=>pwl_('Super'),'equivalentProperties'=>pwl_('Equivalent'),'inverseOf'=>pwl_('Inverse'));
echo($tab->show($tabs));
$cConfig=array('AttributeStyle'=>'height:100px;width:225px;');
if(!$editable)
	$cConfig['readonly']=true;
$cs=new selectProperty($cConfig);
foreach($tabs as $key=>$val)
	echo('<div id="'.$key.'" class="tabarea" style="width:248px; height:130px;">'.
		(method_exists($property,"list$key")?
			$cs->edit($key,!empty($_REQUEST['parent'])&&$key=='superProperties'?$_REQUEST['parent']:array_keys(call_user_func(array($property,"list$key"))),$key=='inverseOf'?array('cardinalityMax'=>1):
			array()):'').'</div>');
echo('</div>');
if($widgetsclass=pwlGetSysOntClass('WidgetConfiguration')) { ?>
<h2><?=pwlHTMLOptional('widget','property').pwl_("Widget") ?></h2>
<div id="widget">
<?
if($widgetSelectionInstance=pwlFindWidget($property))
	$widgetInstance=pwlGetSysOntInstance($widgetSelectionInstance->getPropertyValuePlain('widgetConfiguration'));
$widgets['']='Default';
foreach($widgetsclass->listSubClassesRecursive() as $subclass)
	foreach($subclass->listInstances() as $instance)
		$widgets[$instance->getURI()]=$subclass->getLocalName().': '.$instance->getLocalName();
echo($s->edit('widget',!empty($widgetInstance)?$widgetInstance->getURI():'',$widgets));
?><input type="button" value="<?= pwl_("configure") ?>"
onclick="if(this.form.elements['widget'].value!=0) powl.winopen('../instances/instance.php?model=<?=urlencode($_POWL['SysOnt']->modelURI)?>&uri='+encodeURIComponent(this.form.elements['widget'].value))">
</div>
<? } ?>
<?=pwlResourceMetaShow($property,true,$editable).($editable?pwlResourceVersioning($property).'<br /><INPUT type="submit" value="'.pwl_($isNew?'Create':'Save changes').'" onclick="powl.wait(this)" />':'')?>
</form>
<? pwlHTMLFooter(); ?>