<?
/**
 * RDF triple viewer.
 * 
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: index.php,v 1.49 2004/11/22 22:03:15 soerenauer Exp $
 **/

include('../../include.php');
pwlHTMLHeader();

if($_SERVER['REQUEST_METHOD']=='POST' && !$powl->aclCheck('Edit',$_ET['rdfsmodel']))
	pwlDeny();
if(!empty($_POST['delete']))
	foreach($_POST['delete'] as $stmn) {
		$stm=unserialize($stmn);
		$subj=$stm['sIs']=='b'?new Blanknode($stm['s']):$stm['s'];
		$obj=$stm['oIs']=='b'?new Blanknode($stm['o']):($stm['oIs']=='l'?new RDFSLiteral($stm['o'],$stm['oLang'],$stm['oDtype']):$stm['o']);
		$_ET['rdfsmodel']->remove($subj,$stm['p'],$obj);
	}

switch(!empty($_REQUEST['action'])) {
	case 'delete':
		if($_REQUEST['lang'] || $_REQUEST['dtype']) {
			$o=new Literal($_REQUEST['obj'],$_REQUEST['lang']);
			$o->setDatatype($_REQUEST['dtype']);
		} else
			$o=new Resource($_REQUEST['obj']);
		$_ET['rdfsmodel']->remove($_REQUEST['subj'],$_REQUEST['pred'],$o);
		break;
	case 'replace':
		foreach($_REQUEST['where'] as $where=>$val) {
			$rmod=$_ET['rdfsmodel']->findRegex(
				$where=='subj'?'/.*'.preg_quote($_REQUEST['from']).'.*/':NULL,
				$where=='pred'?'/.*'.preg_quote($_REQUEST['from']).'.*/':NULL,
				$where=='obj'?'/.*'.preg_quote($_REQUEST['from']).'.*/':NULL);
			foreach($rmod->triples as $stm) {
				$_ET['rdfsmodel']->remove($stm);
				$s=$where=='subj'?new Resource(str_replace($_REQUEST['from'],$_REQUEST['to'],$stm->subj->getURI())):$stm->subj;
				$p=$where=='pred'?new Resource(str_replace($_REQUEST['from'],$_REQUEST['to'],$stm->pred->getURI())):$stm->pred;
				$o=$where=='obj'?new Resource(str_replace($_REQUEST['from'],$_REQUEST['to'],$stm->obj->getURI())):$stm->obj;
				$_ET['rdfsmodel']->add(new Statement($s,$p,$o));
			}
		}
		break;
}
?>
<h1><?= pwl_("RDF triples") ?></h1>
<? if(empty($_ET['rdfsmodel'])) {
	echo(pwl_('<b>No model selected.</b><br/>Please select a model first!').'</body>');
	pwlHTMLFooter();
	exit;
} ?>
<form><b><?= pwl_("Filter") ?>:</b>&nbsp;&nbsp;&nbsp;
<?
$s=new select(array('cardinalityMax'=>1));
$c=new checkbox(array('cols'=>'','separator'=>'&nbsp;&nbsp;&nbsp;'));
echo($c->edit('spo',!empty($_REQUEST['spo'])?$_REQUEST['spo']:'',array('subject'=>pwl_('Subjects'),'predicate'=>pwl_('Predicates'),'object'=>pwl_('Objects'))).'&nbsp;&nbsp;&nbsp;');
echo($s->edit('compare',!empty($_REQUEST['compare'])?$_REQUEST['compare']:'',array(''=>pwl_('exactly matching'),'starts'=>pwl_('starting with'),'contains'=>pwl_('containing'),'regex'=>pwl_('regex matching'))));
?>
<input type="text" name="search" value="<?=!empty($_REQUEST['search'])?$_REQUEST['search']:''?>"/>
<input type="submit" value="<?= pwl_("Go") ?>" onclick="powl.wait(this)"/>
</form>
<?
$start=!empty($_REQUEST['start'])?$_REQUEST['start']:0;
$count=pwlSessionVar($_SERVER['PHP_SELF'],'count');
if(empty($_REQUEST['spo']))
	$rs=$_ET['rdfsmodel']->query(NULL,NULL,NULL,$start,$count);
else
	$rs=$_ET['rdfsmodel']->search($_REQUEST['search'],$_REQUEST['spo'],!empty($_REQUEST['compare'])?$_REQUEST['compare']:'',$start,&$count);
$erg=$rs->_maxRecordCount?$rs->_maxRecordCount:$rs->_numOfRows;
echo(pwlListHead($start,$count,$erg));
?>
<form method="post" name="delform">
<table class="tripletable"><tr>
	<? if($powl->aclCheck('Edit',$_ET['rdfsmodel'])) { ?>
	<th><a href="javascript:powl.toggleChecked(document.forms['delform'],'delete');">S</a></th>
	<? } ?>
	<th><?= pwl_("Nr.") ?></th><th><?= pwl_("Subject") ?></th><th><?= pwl_("Predicate") ?></th><th><?= pwl_("Object") ?></th>
	<? if($powl->aclCheck('Edit',$_ET['rdfsmodel'])) { ?>
	<th><?= pwl_("Action") ?></th>
	<? } ?>
</tr>
<?
if($erg==0)
	echo('<tr><td colspan="6">'.pwl_('No triples found!').'</td></tr>');
$i=$start;
while($stm=$_ET['rdfsmodel']->fetchStatementFromRecordSet($rs)) {
$stmn=array(
	's'=>$stm->subj->getURI(),
	'p'=>$stm->pred->getURI(),
	'o'=>$stm->obj->getLabel(),
	'sIs'=>$_ET['rdfsmodel']->_getNodeFlag($stm->subj),
	'oIs'=>$_ET['rdfsmodel']->_getNodeFlag($stm->obj),
);
if(is_a($stm->obj,'Literal')) {
	$stmn['oLang']=$stm->obj->getLanguage();
	$stmn['oDtype']=$stm->obj->getDatatype();
}
	echo('<tr class="'.(++$i%2==0?'':'even').'">
	        '.($powl->aclCheck('Edit',$_ET['rdfsmodel'])?'<td><input id="delformelem'.$i.'" type="checkbox" name="delete[]" value=\''.serialize($stmn).'\'></td>':'').'
	        <td>'.$i.'</td><td nowrap="nowrap">'.pwlRenderNode($stm->subj).'</td><td nowrap="nowrap">'.pwlRenderNode($stm->pred).'</td><td>'.pwlRenderNode($stm->obj).'</td>
	        '.($powl->aclCheck('Edit',$_ET['rdfsmodel'])?'<td>
	           <a href="#" onclick="open(\'stm_edit.php?subj='.urlencode($stm->subj->getURI()).'&pred='.urlencode($stm->pred->getURI()).'&obj[value]='.urlencode(is_a($stm->obj,'Resouce')?$stm->obj->getURI():$stm->obj->getLabel()).(is_a($stm->obj,'Literal')?'&obj[type]=literal&obj[lang]='.urlencode($stm->obj->getLanguage()).'&obj[dtype]='.urlencode($stm->obj->getDatatype()):'').'\',\'stm_edit\',\'width=250,height=350,resizable=1,scrollbars=1\');" title="Edit"><img src="../../images/edit.gif"></a>
	           <a onclick="if(confirm(\'Do you really want to delete this object?\')) { form=document.forms[\'delform\']; form.reset(); document.getElementById(\'delformelem\'+'.$i.').checked=\'true\'; form.submit();}" href="#" title="'.pwl_('Delete').'"><img src="../../images/delete.gif"></a>
			</td>':'').'
	      </tr>');
}
?>
<tr><th colspan="6" align="left">
	<? if($powl->aclCheck('Edit',$_ET['rdfsmodel'])) { ?>
	<img src="../../images/item_ltr.png">&nbsp;<a href="javascript:if(confirm('<?= pwl_('Do you really want to delete this object?') ?>')) document.forms['delform'].submit();"><?= pwl_("Delete selected") ?></a>&nbsp;&nbsp;&nbsp;<img src="../../images/item_ltr.png">&nbsp;<a href="#" onclick="open('stm_edit.php','stm_edit','width=250,height=250');"><?= pwl_("Add triple") ?></a>
	<? } else echo('&nbsp;'); ?>
</th></tr>
</table>
</form>
<? if($powl->aclCheck('Edit',$_ET['rdfsmodel'])) { ?>
<h2><?= pwl_("Replace") ?></h2>
<form method="post">
<input type="hidden" name="action" value="replace" />
<b><?= pwl_("Where") ?>:</b><br />
<input type="checkbox" name="where[subj]" value="true"> <?= pwl_("Subjects") ?>
<input type="checkbox" name="where[pred]" value="true"> <?= pwl_("Predicates") ?>
<input type="checkbox" name="where[obj]" value="true"> <?= pwl_("Objects") ?><br />
<table class="blind"><tr><td>
<b><?= pwl_("From") ?>:</b><br />
<input type="text" name="from" />
</td><td><b><?= pwl_("To") ?>:</b><br />
<input type="text" name="to" />
</td></tr></table>
<input type="submit" value="<?=pwl_('Submit')?>" onclick="powl.wait(this)" />
</form>
<? } ?>
<? pwlHTMLFooter(); ?>