<?
/**
 * RDF literal editor.
 * 
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: node.php,v 1.11 2005/05/27 08:51:12 soerenauer Exp $
 **/

include('../../include.php');
pwlHTMLHeader();

if(!$powl->aclCheck('Edit',$_ET['rdfsmodel']))
	pwlDeny();

$subj=$_ET['rdfsmodel']->resourceF($_REQUEST['subj']);
$pred=$_ET['rdfsmodel']->propertyF($_REQUEST['pred']);

# update/create widget selection
if($_REQUEST['widget']) {
	if(!$widgetInstance=pwlFindWidget($pred)) {
		$widgetInstance=$GLOBALS['_POWL']['SysOnt']->addInstance($GLOBALS['_POWL']['SysOnt']->getUniqueResourceURI('Instance'),'WidgetSelection');
		$widgetInstance->setPropertyValue('widgetProperty',$pred->getURI());
		$widgetInstance->setPropertyValue('widgetConfiguration',$_REQUEST['widget']);
	} else
		$widgetInstance->setPropertyValue('widgetConfiguration',$_REQUEST['widget']);
}

# get widget object
if($subj)
	foreach($subj->type() as $type)
		if($widget=pwlGetWidgetObject($type,$pred,array('name'=>'obj[value]','cardinality'=>1,'AttributeStyle'=>'width:85%;'),true))
			break;
if(!$widget) {
	if($pred->isObjectProperty())
		$widget=new selectResource();
	else if($pred->isDatatypeProperty())
		$widget=new editLiteral();
	else
		$widget=new editNode();
}

if($_POST) {
	if(method_exists($widget,'process'))
		$obj=$widget->process('obj');
	else if($_REQUEST['obj']['value'] || $_REQUEST['obj']['dtype'] || $_REQUEST['obj']['lang']) {
		if($_REQUEST['obj']['lang'])
			$_REQUEST['obj']['lang']=$_REQUEST['obj']['lang']=='Lang'?'':$_REQUEST['obj']['lang'];
		$obj=$_POST['obj']['type']=='resource'?$_ET['rdfsmodel']->resourceF($_REQUEST['obj']['uri']):new RDFSLiteral($_REQUEST['obj']['value'],$_REQUEST['obj']['lang'],$_REQUEST['obj']['dtype']);
	}
	$success=true;
	if($_REQUEST['oldobj']['type']!=$_REQUEST['obj']['type'] ||
		$_REQUEST['oldobj']['value']!=$obj->getLabel() || $_REQUEST['oldobj']['dtype']!=$obj->dtype || $_REQUEST['oldobj']['lang']!=$obj->lang) {
		$_ET['rdfsmodel']->logStart('Property values changed',$pred->getLocalName());
		if($_REQUEST['obj']['type']=='remove' || $_REQUEST['oldobj']['value'] || $_REQUEST['oldobj']['dtype'] || $_REQUEST['oldobj']['lang']) {
			$oo=$_POST['oldobj']['type']=='resource'?$_ET['rdfsmodel']->resourceF($_REQUEST['obj']['value']):new RDFSLiteral($_REQUEST['oldobj']['value'],$_REQUEST['oldobj']['lang'],$_REQUEST['oldobj']['dtype']);
#			$oo=new RDFSLiteral($_REQUEST['oldobj']['value'],$_REQUEST['oldobj']['lang'],$_REQUEST['oldobj']['dtype']);
#print_r($_REQUEST);
			$success=$_ET['rdfsmodel']->remove($subj,$pred,$oo);
		}
#print_r($obj);
#exit;
#print_r($obj);
		if($_REQUEST['obj']['type']!='remove' && $obj)
			$success=$_ET['rdfsmodel']->add($subj,$pred,$obj)&&$success;
		$_ET['rdfsmodel']->logEnd();
	}
#exit;
	if(!$success) {
		echo('<input type="button" value="Close" onclick="opener.location.reload();window.close();" />');
		pwlHTMLFooter();
		exit;
	} else if($_REQUEST['obj']['type']!='remove' && !$_ET['rdfsmodel']->getProperty($_REQUEST['pred']) && strpos($_REQUEST['pred'],'rdf:')!==0 && strpos($_REQUEST['pred'],'rdfs:')!==0 && stripos($_REQUEST['pred'],'owl:')!==0
		&& stripos($_REQUEST['pred'],RDF_NAMESPACE_URI)!==0 && stripos($_REQUEST['pred'],RDF_SCHEMA_URI)!==0 && stripos($_REQUEST['pred'],OWL_URI)!==0) {
		echo('<h1>Property <i>'.$_REQUEST['pred'].'</i> not yet defined</h1><p>This property is not yet defined. Please consider defining <a href="../properties/property.php?uri='.urlencode($_REQUEST['pred']).'">'.$_REQUEST['pred'].'</a> now!</p><input type="button" value="Close" onclick="opener.location.reload();window.close();" />');
		pwlHTMLFooter();
		exit;
	} else if($_REQUEST['action']!='stay')
		echo('<script language="javascript">opener.location.reload();close();</script>');
	else
		unset($_REQUEST['obj']);
}
?>
<h1>Edit node: <?=$subj->getLocalName()?> <?=$pred->getLocalName()?></h1>
<form method="post" enctype="multipart/form-data">
<input type="hidden" name="model" value="<?=$_REQUEST['model']?>" />
<input type="hidden" name="subj" value="<?=$_REQUEST['subj']?>" />
<input type="hidden" name="pred" value="<?=$_REQUEST['pred']?>" />
<input type="hidden" name="oldobj[value]" value="<?=htmlentities($_REQUEST['obj']['value'])?>" />
<input type="hidden" name="oldobj[type]" value="<?=$_REQUEST['obj']['type']?>" />
<input type="hidden" name="oldobj[lang]" value="<?=$_REQUEST['obj']['lang']?>" />
<input type="hidden" name="oldobj[dtype]" value="<?=$_REQUEST['obj']['dtype']?>" />
<?
if($widgetsclass=pwlGetSysOntClass('WidgetConfiguration')) {
	if($widgetSelectionInstance=pwlFindWidget($pred))
		$widgetInstance=pwlGetSysOntInstance($widgetSelectionInstance->getPropertyValuePlain('widgetConfiguration'));
	$widgets['']='Default';
	foreach($widgetsclass->listSubClassesRecursive() as $subclass)
		foreach($subclass->listInstances() as $instance)
			$widgets[$instance->getURI()]=$subclass->getLocalName().': '.$instance->getLocalName();
	$s=new select(array('cardinalityMax'=>1,'onchange'=>'document.location.href=document.location.href+\'&widget=\'+encodeURIComponent(this.value)'));
	echo($s->edit('widget',!empty($widgetInstance)?$widgetInstance->getURI():'',$widgets).'<br />');
}
echo($widget->edit('obj',$_REQUEST['obj'],array('cardinality'=>1,'AttributeStyle'=>'width:85%;')));
if(!$_REQUEST['obj'])
	echo('<p><input type="radio" name="action" value="close" checked="checked" /> Close window&nbsp;&nbsp;&nbsp;<input type="radio" name="action" value="stay" /> Add another property </p>');
?><br />
<input type="submit" value="<?=pwl_('Submit')?>" onclick="powl.wait(this)" >
</form>
<? pwlHTMLFooter(); ?>