<?
include('../../../../include.php');
pwlHTMLHeader();
?>
<h1>Full-text Search</h1>

<p>pOWL's full-text search capability enables you to search for resource names and literal values containing one or multiple search strings.</p>

<p>As of Version 4.0.1, MySQL can also perform boolean full-text searches.</p>


<p>The boolean full-text search capability supports the following operators: </p>

<table>
<tr><th>Operator</th><th>Explanation</th></tr>
<tr><td>+ </td><td>
A leading plus sign indicates that this word must be present in every row returned.</td></tr>
<tr><td>- </td><td>
A leading minus sign indicates that this word must not be present in any row returned. 
By default (when neither plus nor minus is specified) the word is optional, but the rows that contain it will be rated higher.</td></tr>
<tr><td>< > </td><td>
These two operators are used to change a word's contribution to the relevance value that is assigned to a row. The < operator decreases the contribution and the > operator increases it. See the example below.</td></tr>
<tr><td>( ) </td><td>
Parentheses are used to group words into subexpressions.</td></tr>
<tr><td>~ </td><td>
A leading tilde acts as a negation operator, causing the word's contribution to the row relevance to be negative. It's useful for marking noise words. A row that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator. </td></tr>
<tr><td>* </td><td>
An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended. </td></tr>
<tr><td>" </td><td>
The phrase, that is enclosed in double quotes ", matches only rows that contain this phrase literally, as it was typed. </td></tr>
</table>

<p>And here are some examples: </p>

<table>
<tr><th>Example</th><th>Explanation</th></tr>
<tr><td>apple banana </td><td>
find rows that contain at least one of these words. </td></tr>
<tr><td>+apple +juice </td><td>
... both words. </td></tr>
<tr><td>+apple macintosh </td><td>
... word ``apple'', but rank it higher if it also contain ``macintosh''. </td></tr>
<tr><td>+apple -macintosh </td><td>
... word ``apple'' but not ``macintosh''. </td></tr>
<tr><td>+apple +(>turnover <strudel) </td><td>
... ``apple'' and ``turnover'', or ``apple'' and ``strudel'' (in any order), but rank ``apple pie'' higher than ``apple strudel''. </td></tr>
<tr><td>apple* </td><td>
... ``apple'', ``apples'', ``applesauce'', and ``applet''. </td></tr>
<tr><td>"some words" </td><td>
... ``some words of wisdom'', but not ``some noise words''. 
</td></tr>
</table>


<? pwlHTMLFooter(); ?>