<?
/**
 * Full-text search.
 * 
 * @package POWL
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: index.php,v 1.9 2004/12/27 15:03:20 soerenauer Exp $
 **/

include('../../include.php');
pwlHTMLHeader();

$model=$GLOBALS['_ET']['rdfsmodel'];
$type=empty($_REQUEST['type'])?'':$_REQUEST['type'];
echo('<h1>'.pwl_('Full-text Search').'</h1>
	<script language="javascript">var inp; parent.frames[\'docu\'].location.href=\'doc/en\';</script>');
if(empty($_ET['rdfsmodel'])) {
	echo(pwl_('<b>No model selected.</b><br/>Please select a model first!').'</body>');
	pwlHTMLFooter();
	exit;
}

if(strtolower($_POWL['db']['type'])!='mysql') {
	echo(pwl_('The full-text search is currently only supported for MySQL.'));
	exit;
}

foreach($model->dbConn->getAll('SHOW INDEX FROM statements') as $idx)
	if($idx[4]=='subject' && ($idx[10]=='FULLTEXT' || $idx[9]=='FULLTEXT'))
		$ft_subject=true;
	else if($idx[4]=='object' && ($idx[10]=='FULLTEXT' || $idx[9]=='FULLTEXT'))
		$ft_object=true;
if(!$ft_subject) {
	if($_REQUEST['ft_create']=='subject') {
		$ft_subject=true;
		$model->dbConn->execute('ALTER TABLE `statements` ADD FULLTEXT (`subject`)');
	} else
		echo('<p>Full-text index on subjects not yet created: Please create a full-text index on row "subjects" in the "statements" table manually!<!--<a href="?ft_create=subject">create</a> (may take long)--></p>');
}
if(!$ft_object) {
	if($_REQUEST['ft_create']=='object') {
		$model->dbConn->execute('ALTER TABLE `statements` ADD FULLTEXT (`object`)');
		$ft_object=true;
	} else
		echo('<p>Full-text index on objects not yet created: Please create a full-text index on row "objects" in the "statements" table manually!<!--<a href="?ft_create=object">create</a> (may take long)--></p>');
}

echo(pwl_('Search for:').' <form><input type="text" name="search" value="'.(empty($_REQUEST['search'])?'':$_REQUEST['search']).'">');
if($ft_subject) {
	$types=array(''=>'Literals','Classes'=>'Classes','Properties'=>'Properties','Instances'=>'Instances');
	if(!$ft_object) {
		unset($types['']);
		$type=$type?$type:'Classes';
	}
	echo(checkbox::edit('type',$type,$types,array('cardinality'=>1,'Attributes'=>'onclick="this.form.submit()"')));
}
echo('&nbsp;&nbsp;&nbsp;<input type="submit">');

if(!empty($_REQUEST['search'])) {
	$start=!empty($_REQUEST['start'])?$_REQUEST['start']:0;
	$count=pwlSessionVar($_SERVER['PHP_SELF'],'count');
#	$sql='SELECT *,MATCH('.($type?'subject':'object').') AGAINST (\''.$_REQUEST['search'].'\' /*!40001 IN BOOLEAN MODE */) AS score FROM statements
#		WHERE MATCH('.($type?'subject':'object').') AGAINST (\''.$_REQUEST['search'].'\' /*!40001 IN BOOLEAN MODE */) AND modelID IN('.$model->getModelIds().')'.
#		($type?' AND object_is=\'r\'':' AND object_is=\'l\'');
#	if($type=='Classes')
#		$sql.=' AND predicate=\''.$model->_dbId('RDF_type').'\' AND object IN (\''.join('\',\'',array_keys($model->vocabulary['Class'])).'\')';
#	else if($type=='Properties')
#		$sql.=' AND predicate=\''.$model->_dbId('RDF_type').'\' AND object IN (\''.join('\',\'',array_keys($model->vocabulary['Property'])).'\')';
#	else if($type=='Instances')
#		$sql.=' AND predicate=\''.$model->_dbId('RDF_type').'\' AND object NOT IN (\''.join('\',\'',array_keys(array_merge($model->vocabulary['Class'],$model->vocabulary['Property']))).'\')';
##print_r($sql);
#	$rs=$model->dbConn->PageExecute($sql,$count,$start/$count+1);
#	$erg=$rs->_maxRecordCount?$rs->_maxRecordCount:$rs->_numOfRows;
#
	if($type=='Instances') {
		$is=new InstanceSearch($model,$_REQUEST['search']);
		if($_REQUEST['classes'])
			$is->classes=array_filter($_REQUEST['classes']);
		if($_REQUEST['properties'])
			$is->properties=array_filter($_REQUEST['properties']);
		$se=new select(array('cardinality'=>1,'onchange'=>'this.form.submit()'));
		echo('<br />Filter:&nbsp;');
		$cls['']='Classes';
		foreach($is->listClasses() as $c) {
			$cl=$model->classF($c[0]);
			$cls[$c[0]]=$cl->getLocalName().' ('.$c[1].')';
		}
		echo($se->edit('classes[]',$_REQUEST['classes'],$cls));
		$cls=array(''=>'Properties');
		foreach($is->listProperties() as $c) {
			$cl=$model->propertyF($c[0]);
			$cls[$c[0]]=$cl->getLocalName().' ('.$c[1].')';
		}
		echo($se->edit('properties[]',$_REQUEST['properties'],$cls));
		$rs=$is->search($start,$count,&$erg);
	} else
		$rs=$model->searchFullText($_REQUEST['search'],$type,$start,$count,&$erg);
	echo(pwlListHead($start,$count,$erg));
	echo('<table><tr><th>'.pwl_('Relevance').'</th><th>'.($type?pwl_('Resource'):pwl_('Subject').'</th><th>'.pwl_('Property').'</th><th>'.pwl_('Literal')).'</th></tr>');
	
	$highlightRx='/(('.str_replace(' ',')|(',preg_quote(preg_replace('/[+-><()~*:""&|]/','',$_REQUEST['search']))).'))/i';
	foreach($rs->getArray() as $row) {
		if(!$max_rel)
			$max_rel=$row['7'];
		$stm=$model->_convertRowToStatement($row);
		echo('<tr><td rowspan="'.$row[8].'">'.($max_rel?round(100*$row['7']/$max_rel).'%':'').'</td>');
		if($type && $type!='Instances')
			echo('<td>'.pwlRenderNode($stm->subj).'</td></tr>');
		if($type=='Instances') {
			echo('<td nowrap="nowrap" rowspan="'.$row[8].'">'.pwlRenderNode($stm->subj,array('node'=>'')).'</td><td nowrap="nowrap">'.
				pwlRenderNode($stm->pred,array('node'=>'')).'</td>');
			echo('<td>'.preg_replace($highlightRx,'<span style="background-color:orange;">\1</span>',pwlRenderNode($stm->obj,array('node'=>''))).'</td></tr>');
			if($row[8]!=1) {
				$rs=$is->searchInstance($stm->subj);
				$a=$rs->getArray();
				array_shift($a);
				foreach($a as $row) {
					$stm=$model->_convertRowToStatement($row);
					echo('<tr><td nowrap="nowrap">'.pwlRenderNode($stm->pred,array('node'=>'')).'</td><td>');
					echo(preg_replace($highlightRx,'<span style="background-color:orange;">\1</span>',pwlRenderNode($stm->obj,array('node'=>''))).'</td></tr>');
				}
			}
		} else
			echo('<td nowrap="nowrap">'.pwlRenderNode($stm->subj,array('node'=>'')).'</td><td nowrap="nowrap">'.
				pwlRenderNode($stm->pred,array('node'=>'')).'</td><td>'.
				preg_replace($highlightRx,'<span style="background-color:orange;">\1</span>',pwlRenderNode($stm->obj,array('node'=>''))).'</td></tr>');
	}
	echo('</table>');
}
?>
</form>
<? pwlHTMLFooter(); ?>