<?php

if (session_name() == '') session_start();
 
require_once('include.php');
require_once('client.php');

// print header
echo pwlHTMLHeader();

// get a pOWL Server to work with
if(isset($_GET['servername']))
{
    $server=$_SESSION['listInstallations'][$_GET['servername']];

    if(isset($server))
    {
        $_SESSION['server']=$server;

        // New Server-> connect and get all Models
        $_SESSION['data']=null;
        $_SESSION['operation']='listModels';
        $_SESSION['object']=$_GET['servername'];

        //$soapclient = new mysoapclient($server);
		global $soapclient;
		
        $result = $soapclient->mycall('powlMethod',array('listModels',array()));

        if(!$soapclient->isfault())
        {
            if($result['type']=='array')
            {
                // data is an array of all Models from remote pOWL
                $_SESSION['data']=$result;
            }
        }
		else
		{
			print print_error($soapclient->mysoapclientFaultMessage);
		}

        $result = $soapclient->mycall('listInstallations',array());
	
        if(!$soapclient->isfault())
        {
            if(is_array($result))
            {
                // data is an array of all remote registered  pOWLs
                $remote_powls = $result;
            }
        }
		else
		{
			print print_error($soapclient->mysoapclientFaultMessage);
		}
    }
}

echo "<h1>Browse Models of Remote Installation</h1>\n";
echo "<p>".$_SESSION['operation']." on ".$_SESSION['object']."</p>\n";
echo "<form method=\"POST\" action='".$_SERVER['PHP_SELF']."'>";

// DEBUGINFO echo "<pre>";  print_r($data);   echo "</pre>";

echo "<table width='100%'>";
echo print_data($_SESSION['data'], 0);
echo "</table>";
echo "</form>";
echo "<br />\n";

if(isset($remote_powls))
{
    echo "<h1>Remote's Registered Installations</h1>";
    echo "<table width='100%'>";
    echo "<tr>
			<th>Installation</th>
			<th>URL</th>
			<th>Action</th> </tr>";

    $keys=array_keys($remote_powls);

    foreach($keys as $key)
    {
            echo "<tr>\n";
            echo "<td>".$key."</td>\n";
            echo "<td>".$remote_powls[$key]."</td>\n";
            echo "<td><a href='register_local.php?name=".urlencode($key)."&server=".urlencode($remote_powls[$key])."'>Add</a></td>\n";
            echo "</tr>\n";
    }
    echo "</table>";
}

// print footer
echo pwlHTMLFooter();

?>