<?
/**
 * RDFSmodel
 * 
 * @package RDFSAPI
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: model.php,v 1.10 2005/02/09 19:31:53 soerenauer Exp $
 * @access public
 **/
class RDFSModel extends DefaultRDFSModel {
	var $metaModel=array(
		'owl:equivalentProperty'=>':OWL-EQUIVALENT-SLOTS',
		'owl:Restriction'=>':OWL-RESTRICTION',
		'owl:AllDifferent'=>':OWL-ALL-DIFFERENT',
		'owl:DeprecatedClass'=>':OWL-DEPRECATED',
		'owl:AnnotationProperty'=>':OWL-ANNOTATION-PROPERTY',
		'owl:DeprecatedProperty'=>':OWL-DEPRECATED',
		'owl:FunctionalProperty'=>':OWL-FUNCTIONAL-PROPERTY',
		'owl:InverseFunctionalProperty'=>':OWL-INVERSE-FUNCTIONAL',
		'owl:SymmetricProperty'=>':OWL-SYMMETRIC',
		'owl:TransitiveProperty'=>':OWL-TRANSITIVE',
		'owl:imports'=>':OWL-ONTOLOGY-IMPORTS',
		'rdfs:subClassOf'=>':DIRECT-SUPERCLASSES',
		'rdfs:subPropertyOf'=>':DIRECT-SUPERSLOTS',
		'rdfs:domain'=>':DIRECT-DOMAIN',
		'rdfs:range'=>':SLOT-VALUE-TYPE',
		'owl:inverseOf'=>':SLOT-INVERSE',
		'rdf:type'=>':DIRECT-TYPE',
		'owl:FunctionalProperty'=>':SLOT-MAXIMUM-CARDINALITY'
	);
	var $propertyTypes=array(
		'owl:InverseFunctionalProperty',
		'owl:SymmetricProperty',
		'owl:TransitiveProperty',
		'owl:DeprecatedProperty',
		'owl:AnnotationProperty',
		'owl:FunctionalProperty'
	);
	function RDFSModel($store,$modelURI) {
		DefaultRDFSModel::DefaultRDFSModel($store,$modelURI);
		$this->table=$store->modelExists($modelURI);
#		$this->resource='DbRDFSResource';
#		$this->vclass='DbRDFSClass';
#		$this->property='DbRDFSProperty';
#		$this->instance='DbRDFSInstance';
	}
	function getType() {
		$this->vocabulary=array(
			'Class'=>array(
				$GLOBALS['OWL_Class']->getURI()=>$GLOBALS['OWL_Class'],
				$GLOBALS['RDFS_Class']->getURI()=>$GLOBALS['RDFS_Class'],
				$GLOBALS['OWL_DeprecatedClass']->getURI()=>$GLOBALS['OWL_DeprecatedClass']),
			'Property'=>array(
				$GLOBALS['RDF_Property']->getURI()=>$GLOBALS['RDF_Property'],
				$GLOBALS['OWL_DatatypeProperty']->getURI()=>$GLOBALS['OWL_DatatypeProperty'],
				$GLOBALS['OWL_ObjectProperty']->getURI()=>$GLOBALS['OWL_ObjectProperty'],
				$GLOBALS['OWL_AnnotationProperty']->getURI()=>$GLOBALS['OWL_AnnotationProperty'],
				$GLOBALS['OWL_DeprecatedProperty']->getURI()=>$GLOBALS['OWL_DeprecatedProperty'],
				$GLOBALS['OWL_FunctionalProperty']->getURI()=>$GLOBALS['OWL_FunctionalProperty'],
				$GLOBALS['OWL_InverseFunctionalProperty']->getURI()=>$GLOBALS['OWL_InverseFunctionalProperty'],
				$GLOBALS['OWL_SymmetricProperty']->getURI()=>$GLOBALS['OWL_SymmetricProperty'],
				$GLOBALS['OWL_TransitiveProperty']->getURI()=>$GLOBALS['OWL_TransitiveProperty'],
				)
		);
		return 'OWL';
	}
	function _dbId($resource) {
		if(is_string($resource))
			$resource=is_a($GLOBALS[$resource],'resource')?$GLOBALS[$resource]:new $this->resource($resource,$this);
		$resource=new $this->resource($resource->getURI(),$this);
		if(!$ln=$this->metaModel[$resource->getLocalName()])
			$ln=$resource->getLocalName();
		$sql='SELECT frame FROM '.$this->table.' stm WHERE slot="2002" AND short_value="'.$ln.(is_a($resource,'literal') && $resource->getLanguage()?' {'.$resource->getLanguage().'}':'').'"';
		$ret=$this->dbConn->getOne($sql);
#		if(!$ret)
#			echo($resource->getLocalName().' not found!<br/>');
		return $ret;
	}
	function _createDynSqlPart_SPO($subject, $predicate, $object) {
		// conditions derived from the parameters passed to the function
		$sql='';
		if($subject!=NULL)
			$sql.=" AND stm.frame='".$this->_dbId($subject)."'";
		if ($predicate!=NULL) {
			if(is_a($object,'Resource') && in_array('owl:'.$object->getLocalName(),$this->propertyTypes)) {
				$sql.=" AND stm.slot='".$this->_dbId($object)."'";
			} else
				$sql.=" AND stm.slot='".$this->_dbId($predicate)."'";
		}
		if ($object!=NULL) {
			if(is_a($object,'Resource') && in_array('owl:'.$object->getLocalName(),$this->propertyTypes))
				$sql.=" AND stm.short_value='true'";
			else
				$sql.=" AND stm.short_value='".$this->_dbId($object)."'";
		}
		return $sql;
	}
	function query($subject,$predicate,$object,$start=0,$count='') {
		if(!is_a($subject,"Resource") && $subject!=NULL)
			$subject=new $this->resource($subject,$this);
		if(!is_a($predicate,"Resource") && $predicate!=NULL)
			$predicate=new $this->resource($predicate,$this);
		if(!is_a($object, "Node") && $object != NULL)
			$object=new $this->resource($object,$this);
		$rep='p.short_value';
		foreach($this->metaModel as $key=>$val)
			$rep='REPLACE('.$rep.',"'.$val.'","'.$key.'")';
		// static part of the sql statement
		foreach($this->propertyTypes as $p)
			$pt.=$this->metaModel[$p]."','";
		$pt="'".substr($pt,0,strlen($pt)-2);
		$sql="SELECT s.short_value,								# subj
				IF(p.short_value IN ($pt),'rdf:type',".$rep."),	# pred
				IFNULL(											# obj
					IF(p.short_value IN ($pt),$rep,o.short_value),
					SUBSTRING_INDEX(IFNULL(stm.short_value,stm.long_value),' {',1)
				),
				IF(												# lang
					stm.value_type=3 AND p.short_value<>':SLOT-VALUE-TYPE' AND stm.short_value LIKE '% {%}',
					TRIM('}' FROM SUBSTRING_INDEX(stm.short_value,' {',-1)),
					''
				),
				'',												# dtype
				'r',											# subject_is
				IF(stm.value_type=3 AND p.short_value<>':SLOT-VALUE-TYPE','l','r')	# object_is
			FROM ".$this->table." stm
				INNER JOIN ".$this->table." s ON (stm.frame=s.frame AND s.slot=2002)
				INNER JOIN ".$this->table." p ON (stm.slot=p.frame AND p.slot=2002)
				LEFT JOIN ".$this->table." o ON (stm.short_value=o.frame AND o.slot=2002)
			WHERE stm.frame>9999 AND p.short_value!=':NAME' AND p.short_value NOT IN (':ROLE',':DIRECT-SUBCLASSES',':DIRECT-SUBSLOTS',':DIRECT-INSTANCES',':DIRECT-TEMPLATE-SLOTS',':OWL-ONTOLOGY-PREFIXES') AND 
				(p.short_value NOT IN ($pt) OR  stm.short_value<>'false') AND
				s.short_value!='ExternalResource' AND
				s.short_value NOT LIKE ':%' AND s.short_value NOT LIKE 'owl:%' AND s.short_value NOT LIKE 'rdf:%' AND s.short_value NOT LIKE 'rdfs:%'";
		// dynamic part of the sql statement
		$sql.=$this->_createDynSqlPart_SPO($subject, $predicate, $object).(!$count?" ORDER BY stm.value_index":'');
#print_r($sql);
		// execute the query
		if($count)
			$recordSet =& $this->dbConn->PageExecute($sql,$count,$start/$count+1);
		else
			$recordSet =& $this->dbConn->execute($sql);
		if (!$recordSet)
			echo $this->dbConn->errorMsg();
		else
			return $recordSet;
	}
	function add($subj,$pred='',$obj='') {
echo "Not yet implemented";
return;
		unset($GLOBALS['_POWL']['cachedata']);
		$statement=!$obj?$subj:$this->_createStatement($subj,$pred,$obj);
		$this->logAdd($statement);
		#queryCacheExpire($this->modelID,$statement->subj,$statement->pred,$statement->obj);
		return parent::add($statement);
	}
	function remove($subj,$pred='',$obj='') {
echo "Not yet implemented";
return;
	}
}
?>