<?
/**
 * RDFSStore
 * 
 * @package RDFSAPI
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: store.php,v 1.3 2005/03/16 18:54:26 soerenauer Exp $
 * @access public
 **/

class POWLStore extends DefaultPOWLStore {
	/**
	 * Create tables and indexes for adodb datadict supported databases
	 *
	 * @throws  SqlError
	 * @access	private
	 */
	function _createTables_Generic() {
		$this->dbConn->startTrans();
	#	$this->dbConn->debug=true;
		$tables=array(
			'models'=>array(
				'fields'=>'
					modelID		I		NOTNULL	AUTO KEY,
					modelURI	C(255)	NOTNULL,
					baseURI		C(255)	NOTNULL',
				'options'=>'',
				'indexes'=>array('modelURI'),
			),
			'statements'=>array(
				'fields'=>'
					modelID		I		NOTNULL,
					subject		C(255)	NOTNULL,
					predicate	C(255)	NOTNULL,
					object		B,
					l_language	C(255),
					l_datatype	C(255),
					subject_is	C(1)	NOTNULL,
					object_is	C(1)	NOTNULL,
					id			I		NOTNULL	AUTO KEY',
				'options'=>'',
				'indexes'=>array('modelID','subject','predicate','object'),
			),
			'namespaces'=>array(
				'fields'=>'
					modelID		I		NOTNULL AUTO KEY,
					namespace	C(255)	NOTNULL KEY,
					prefix		C(255)	NOTNULL',
				'options'=>'',
				'indexes'=>array(),
			)
		);
		$dict=NewDataDictionary($this->dbConn);
		foreach($tables as $tablename=>$table) {
			$dict->ExecuteSQLArray($dict->CreateTableSQL($tablename,$table['fields'],$table['options']));
			foreach($table['indexes'] as $indexname=>$index)
				$dict->ExecuteSQLArray($dict->CreateIndexSQL(is_numeric($indexname)?'idx_'.str_replace('_','',$tablename).'_'.strtr($index,array('_'=>'',','=>'')):$indexname,$tablename,$index));
		}
		if (!$this->dbConn->completeTrans())
			echo $this->dbConn->errorMsg();
	}
	function _createTables_MySQL() {
		$this->_createTables_Generic();
	}
}
?>