<?
/**
 * includes reqired RDFS-API files
 *
 * @package RDFSAPI
 * @author Sren Auer <soeren@auer.cx>
 * @copyright Copyright (c) 2004
 * @version $Id: rdfsapi.php,v 1.37 2006/03/07 23:57:20 soerenauer Exp $
 * @access public
 **/

error_reporting(E_ALL & ~E_NOTICE);
define('RDFSAPI_ERROR','RDFSAPI error ');

// configure RAP constants
define("HIDE_ADVERTISE",true);
#define("USE_CDATA", true);
define('SER_SORT_MODEL', true);
define('UNIC_RDF', true);
define("VALIDATE_IDS", false);
#define("SER_RDF_QNAMES",false);
define('BNODE_PREFIX',uniqid('bN'));
#define('INDENTATION'," ");

// try to guess 'RDFAPI_INCLUDE_DIR' if 'RDFSAPI_INCLUDE_DIR' is defined
if(!defined('RDFAPI_INCLUDE_DIR') && defined('RDFSAPI_INCLUDE_DIR'))
	define('RDFAPI_INCLUDE_DIR',str_replace('rdfsapi/','rdfapi-php/api/',RDFSAPI_INCLUDE_DIR));

require_once(RDFAPI_INCLUDE_DIR.'RdfAPI.php');
require_once(RDFAPI_INCLUDE_DIR.PACKAGE_DBASE);
require_once(RDFAPI_INCLUDE_DIR.PACKAGE_VOCABULARY);

define(RDF_BACKEND_INCLUDE_DIR,RDFSAPI_INCLUDE_DIR.($_POWL['db']['backend']?$_POWL['db']['backend']:'rap').'/');
require_once(RDFSAPI_INCLUDE_DIR.'store.php');
require_once(RDF_BACKEND_INCLUDE_DIR.'store.php');
require_once(RDFSAPI_INCLUDE_DIR.'model.php');
require_once(RDF_BACKEND_INCLUDE_DIR.'model.php');
require_once(RDFSAPI_INCLUDE_DIR.'literal.php');
require_once(RDF_BACKEND_INCLUDE_DIR.'literal.php');
require_once(RDFSAPI_INCLUDE_DIR.'resource.php');
require_once(RDF_BACKEND_INCLUDE_DIR.'resource.php');
require_once(RDFSAPI_INCLUDE_DIR.'class.php');
require_once(RDF_BACKEND_INCLUDE_DIR.'class.php');
require_once(RDFSAPI_INCLUDE_DIR.'property.php');
require_once(RDF_BACKEND_INCLUDE_DIR.'property.php');
require_once(RDFSAPI_INCLUDE_DIR.'instance.php');
require_once(RDF_BACKEND_INCLUDE_DIR.'instance.php');

require_once(RDFSAPI_INCLUDE_DIR.'search.php');

$default_prefixes['owl']='http://www.w3.org/2002/07/owl#';

# since php 5.0.5 arg has to be passed by reference to array_shift
function parray_shift($array){
	return array_shift($array);
}

function isBNode($node) {
	if(is_a($node,'Blanknode') || (method_exists($node,'isBlankNode') && $node->isBlankNode()))
		return true;
	else false;
}
function cacheGetUidFromArgs(&$args) {
	return crc32(serialize($args));
	foreach($args as $arg)
		if(is_object($arg)) {
			if(method_exists($arg,'toString'))
				$uid.=$arg->toString();
			else
				$uid.=serialize($arg);
		} else if(is_array($arg))
			$uid.=serialize($arg);
		else if(is_null($arg))
			$uid.='NULL';
		else $uid.=$arg;
	return crc32($uid);
}
function cache($fn,$args=array(),$value=NULL) {
	if(!$GLOBALS['_POWL']['cache'])
		return $value;
	$cache=&$GLOBALS['_POWL']['cachedata'];
	$uid=cacheGetUidFromArgs($args);
	if(func_num_args()==3)
		$cache[$fn][$uid]=$value;
	else
		$value=isset($cache[$fn][$uid])?$cache[$fn][$uid]:NULL;
	return $value;
}
/**
 * CREATE TABLE `cache` (
 *   `id` int(11) NOT NULL auto_increment,
 *   `trigger1` varchar(255) NOT NULL default '',
 *   `trigger2` varchar(255) NOT NULL default '',
 *   `trigger3` varchar(255) NOT NULL default '',
 *   `function` varchar(255) NOT NULL default '',
 *   `args` varchar(255) NOT NULL default '',
 *   `model` int(11) NOT NULL default '0',
 *   `resource` varchar(255) NOT NULL default '',
 *   `value` longblob NOT NULL,
 *   PRIMARY KEY  (`id`),
 *   UNIQUE KEY `function` (`function`,`args`,`model`,`resource`)
 * )
 */
Class stmCache {
	var $value=NULL;
	function stmCache($function,$args=array(),$model='',$resource='') {
		$this->fn=$function;
		$this->args=cacheGetUidFromArgs($args);
		$this->model=$model;
		$this->resource=$resource;
		$this->get();
	}
	function get() {
		if($GLOBALS['_POWL']['cache'] && !$this->value && $ret=$GLOBALS['_ET']['store']->dbConn->getOne("SELECT value FROM cache WHERE function='".$this->fn."' AND args='".$this->args."' AND model='".$this->model->modelID."' AND resource='".$this->resource."'"))
			$this->value=unserialize($ret);
		return $this->value;
	}
	function set($value,$triggers=array()) {
		if(!is_array($triggers))
			$triggers=array($triggers);
		$this->value=$value;
		if($GLOBALS['_POWL']['cache']) {
			if(count($triggers)<=3) {
				foreach($triggers as $trigger)
					$tr[]=is_a($trigger,'resource')?$trigger->getURI():$this->model->_dbId($trigger);
			}
			$GLOBALS['_ET']['store']->dbConn->execute("REPLACE cache SET value=".$GLOBALS['_ET']['store']->dbConn->qstr(serialize($value)).",function='{$this->fn}',args='{$this->args}',model='{$this->model->modelID}',resource='{$this->resource}',trigger1='{$tr[0]}',trigger2='{$tr[1]}',trigger3='{$tr[2]}'");
		}
	}
	function expire($stm) {
		if($GLOBALS['_POWL']['cache'])
			foreach(is_a($stm,'statement')?array($stm->subj,$stm->pred,$stm->obj):func_get_args() as $arg)
				if(is_a($arg,'resource'))
					$GLOBALS['_ET']['store']->dbConn->execute("DELETE FROM cache WHERE model='{$arg->model->modelID}' AND
						(trigger1='".$arg->getURI()."' OR trigger2='".$arg->getURI()."' OR trigger3='".$arg->getURI()."')");
	}
}
#class sessCache {
#	function get($id) {
#		return $_SESSION[sessCache][$id];
#	}
#	function save($data,$id) {
#		$_SESSION[sessCache][$id]=$data;
#	}
#}
#class mmCache {
#	function get($id) {
#		return mmcache_get($id);
#	}
#	function save($data,$id) {
#		mmcache_put($id,$data);
#	}
#}
#class shmCache {
#	var $enabled='true';
#	function get($id) {
#		$int=crc32($id)>0?crc32($id):-crc32($id);
#		if(0 && $shm=@fopen('shm://'.$int,'r')) {
#			$data='';
#			while(!feof($shm))
#				$data.=fgets($shm);
#			fclose($shm);
#			return unserialize($data);
#		} else
##		echo('cache miss');
#			return false;
#	}
#	function save($data,$id) {
#		static $c;
#		$data=serialize($data);
#		$int=crc32($id)>0?crc32($id):-crc32($id);
#var_dump('shm://'.$int.':'.strlen($data),'c');
#if($c++==13) exit;
#		if($shm=fopen('shm://0x'.dechex($int).':'.strlen($data),'c')) {
#			fwrite($shm,$data);
#			fclose($shm);
#		}
#	}
#}
#
##require_once('Stream/SHM.php');
##stream_register_wrapper('shm','Stream_SHM') or die("can't register shm");
#
#@include_once('Cache/Lite.php');
#define('DIR_SEP', DIRECTORY_SEPARATOR);
#
#if(class_exists('Cache_Lite')) {
#class Hashed_Cache_Lite extends Cache_Lite
#{
#    /**
#    * Memory caching variable
#    *
#    * @var array $_memoryCache
#    */
#    var $_memoryCache = NULL;
#
#    /**
#    * Test if a cache is available and (if yes) return it - Original version by Fabien MARTY <fab@php.net>
#    *
#    * @param string $id cache id
#    * @param string $group name of the cache group
#    * @param boolean $doNotTestCacheValidity if set to true, the cache validity won't be tested
#    * @return string data of the cache (or false if no cache available)
#    * @access public
#    */
#    function get($id, $group = 'default', $doNotTestCacheValidity = false)
#    {
#        $this->_id = $id;
#        $this->_group = $group;
#
#        if ($this->_caching) {
#			if (!empty($this->_memoryCache[$group.'-'.$id])) {
#				return unserialize($this->_memoryCache[$group.'-'.$id]);
#			} else {
#				$this->_setFileName($id, $group);
#				if ($doNotTestCacheValidity) {
#					if (file_exists($this->_file)) {
#						$this->_memoryCache[$group.'-'.$id] = $this->_read();
#						return ( unserialize($this->_memoryCache[$group.'-'.$id]) );
#					}
#				} else {
#					if (@filemtime($this->_file) > $this->_refreshTime) {
#						$this->_memoryCache[$group.'-'.$id] = $this->_read();
#						return ( unserialize($this->_memoryCache[$group.'-'.$id]) );
#					}
#				}
#			}
#        }
#        return false;
#    }
#
#    /**
#    * Make a file name (with path)
#    *
#    * @param string $id cache id
#    * @param string $group name of the group
#    * @access private
#    */
#    function _setFileName($id, $group)
#    {
#		//CRC32 with SUBSTR is still faster then MD5.
#		$encoded_id = substr(crc32($id),1);
#		//$encoded_id = md5($id);
#
#		//Generate just the directory, so it can be created.
#		//Groups will have there own top level directory, for quick/easy purging of an entire group.
#		$dir = $this->_cacheDir.$group.'/'.substr($encoded_id,0,3);
#		$this->_create_dir_structure($dir);
#
#		$this->_file = $dir.'/'.$encoded_id;
#    }
#
#    /**
#    * Create full directory structure, Ripped straight from the Smarty Template engine.
#	* Version:     2.3.0
#	* Copyright:   2001,2002 ispi of Lincoln, Inc.
#    *
#    * @param string $dir Full directory.
#    * @access private
#    */
#    function _create_dir_structure($dir)
#    {
#        if (!@file_exists($dir)) {
#            $dir_parts = preg_split('!\\'.DIR_SEP.'+!', $dir, -1, PREG_SPLIT_NO_EMPTY);
#            $new_dir = ($dir{0} == DIR_SEP) ? DIR_SEP : '';
#            foreach ($dir_parts as $dir_part) {
#                $new_dir .= $dir_part;
#                if (!file_exists($new_dir) && !mkdir($new_dir, 0771)) {
#					Cache_Lite::raiseError('Cache_Lite : problem creating directory \"$dir\" !', -3);
#                    return false;
#                }
#                $new_dir .= DIR_SEP;
#            }
#        }
#    }
#}
#
##$GLOBALS['clite']=new Hashed_Cache_Lite(array('cacheDir'=>'C:\\temp\\','automaticSerialization'=>true));
#}
##$GLOBALS['clite']=new shmCache();
#
#function queryCacheKey($modelId,$s,$p,$o,$start,$erg) {
#	$idArray=array($modelId,
#		(is_a($s,'Resource')?$s->getURI():'NULL'),
#		(is_a($p,'Resource')?$p->getURI():'NULL'),
#		(is_a($o,'Resource')?$o->getURI():(is_a($o,'Literal')?$o->getLabel().'|'.$o->getDatatype().'|'.$o->getLanguage():'NULL')),
#		$start,
#		$erg);
#
#	return join('|',$idArray);
#}
#
#function & queryCacheGet($modelId,$s,$p,$o,$start,$erg) {
#	if(empty($GLOBALS['clite']))
#		return false;
#	$id=queryCacheKey($modelId,$s,$p,$o,$start,$erg);
#	return $GLOBALS['clite']->get($id);
#}
#
#function queryCacheSet(&$data,$modelId,$s,$p,$o,$start,$erg) {
#	if(empty($GLOBALS['clite']))
#		return false;
#
#	$res=$GLOBALS['clite']->get('Resources'.$modelId);
#
#	$id=queryCacheKey($modelId,$s,$p,$o,$start,$erg);
#
#	if(is_a($s,'Resource') && (empty($res[$s->getURI()]) || !array_search($id,$res[$s->getURI()])))
#		$res[$s->getURI()][]=$id;
#	if(is_a($p,'Resource') && (empty($res[$p->getURI()]) || !array_search($id,$res[$p->getURI()])))
#		$res[$p->getURI()][]=$id;
#	if(is_a($o,'Resource') && (empty($res[$o->getURI()]) || !array_search($id,$res[$o->getURI()])))
#		$res[$o->getURI()][]=$id;
#
#	$GLOBALS['clite']->save($data,$id);
#	$GLOBALS['clite']->save($res,'Resources'.$modelId);
#}
#
#function queryCacheExpire($modelId,$s,$p,$o) {
#	$res=$GLOBALS['clite']->get('Resources'.$modelId);
#	$removed=array();
#	foreach(array($s,$p,$o) as $r)
#		if(is_a($r,'Resource') && !empty($res[$r->getURI()])) {
#			foreach($res[$r->getURI()] as $id)
#				if(empty($removed[$id])) {
#					$removed[$id]=true;
#					$GLOBALS['clite']->remove($id);
#				}
#			unset($res[$r->getURI()]);
#		}
#	$GLOBALS['clite']->save($res,'Resources'.$modelId);
#}
##print_r($GLOBALS['clite']->get('Resources17'));
?>
